function init()	
	fire_hydrant = FindBody("fire_hydrant")
	pos = GetBodyTransform(fire_hydrant).pos
	pipe = FindBody("pipe")
	shape_pipe = FindShape("shape_pipe")
	SetBodyDynamic(fire_hydrant, false)
	SetBodyDynamic(pipe, false)
	affect_player = FindTrigger("affect_player")
	water = LoadLoop("../../data/level/lee/script/dam/water.ogg")
	fixed = LoadSound("silenced2.ogg")
	first_check = true
end


--Return random number between mi and ma
function rnd(mi, ma)
	return math.random()*(ma-mi)+mi
end


function tick(dt)
	if first_check then
		if IsBodyBroken(fire_hydrant) then---------Active if it's broken
			SetTag(shape_pipe, "interact")
			active = true
			first_check = false
		end
	else
		if GetPlayerInteractShape() == shape_pipe and InputPressed("interact") then
			PlaySound(fixed)
			active = not active
		end
	end

	if active then
		if IsBodyBroken(pipe) then---------Disable with explosives
			RemoveTag(shape_pipe, "interact")
			Delete(fire_hydrant)
			Delete(pipe)
			Delete(affect_player)
			active = false
		end
		if IsPointInTrigger(affect_player, GetPlayerTransform().pos) then----------------Impulse player when get close
			SetPlayerVelocity( Vec(0, 17, 0))
		end

		ParticleType("smoke")
		ParticleFlags(256)
		ParticleRadius(0.2,0.8)
		ParticleAlpha(1, 0)
		ParticleDrag(0.1)
		ParticleGravity(-30)
		ParticleCollide(1, 1, "constant", 0)
		SpawnParticle(VecAdd(pos, Vec(rnd(-0.1,0.1), 1, rnd(-0.1,0.1))), Vec(rnd(-0.5,0.5), 15, rnd(-0.5,0.5)), 1)
		PlayLoop(water, pos, 0.5)
		
		--Collect all dynamic shapes close to the fan (but exclude the fan itself)
		local strength = 650
		local maxDist = 1.1
		QueryRejectBody(fire_hydrant)
		QueryRequire("dynamic")
		local aabbMin = VecAdd(pos, Vec(-maxDist, 0, -maxDist))
		local aabbMax = VecAdd(pos, Vec(maxDist, maxDist, maxDist))
		local shapes = QueryAabbShapes(aabbMin, aabbMax)
		
		--Apply force to dynamic shapes
		for i=1, #shapes do
			local s = shapes[i]
			local hit, cp = GetShapeClosestPoint(s, pos)
	
			local d = VecSub(cp, pos)
			local l = VecLength(d)
			if l > 0 and l < maxDist then
				--Scale factor based on distance to fan
				local scale = 7.0-l/maxDist
				
				--Create an upwards impulse
				local imp = Vec(0, strength*scale, 0)
	
				--Apply impulse to the shape's body 
				local b = GetShapeBody(s)
				ApplyBodyImpulse(b, cp, imp)
			end
		end
	end
end