#include "script/common.lua"
visible = 0
function init()
	SetValue("visible", 1.0, "cosine", 0.5)
	SetBool("disabled", true)
	menu = false
	force = false
	explosives = false
	powers_ON = false
	con0 = true
	mod0 = true
-------------------SOUNDS---------------------------
	inputpressed = LoadSound("warning-beep.ogg")
	inputdown = LoadSound("error.ogg")
	disableSound = LoadSound("disableSound.ogg")
-----------------REMAP_KEYS-------------------------
	if not GetString("savegame.mod.remap_F8") then
		SetString("savegame.mod.remap_F8", "M")
	end
	remap_F8 = GetString("savegame.mod.remap_F8")
	SetString("hud.notification", "Press ".. remap_F8 .." to enable the keys")

	if not GetString("savegame.mod.remap_F7") then
		SetString("savegame.mod.remap_F7", "F7")
	end
	remap_F7 = GetString("savegame.mod.remap_F7")

	if not GetString("savegame.mod.remap_q") then
		SetString("savegame.mod.remap_q", "Q")
	end
	remap_q = GetString("savegame.mod.remap_q")

	if not GetString("savegame.mod.remap_z") then
		SetString("savegame.mod.remap_z", "Z")
	end
	remap_z = GetString("savegame.mod.remap_z")

	if not GetString("savegame.mod.remap_mmb") then
		SetString("savegame.mod.remap_mmb", "Mmb")
	end
	remap_mmb = GetString("savegame.mod.remap_mmb")

-------------------LIGHTS----------------------------------
	street_power = false
	lights_on = false
	glasses = FindShapes("glass", true)
	lamps = FindLights("lamp", true)
	lamp_post = FindLights("lamp_post", true)
	for i=1,#lamp_post do
		street = lamp_post[i]
		SetLightEnabled(street, false)
	end
	switch = FindShape("switch", true)
---------------STREET_PROPS-----------------------------
	street_props = FindShapes("street_props", true)
	lamp_post_body = FindShapes("lamp_post_body", true)
-----------------WEATHER---------------------------------
	r0 = true
	s0 = true
	w0 = true
	wt0 = true
	DeadLight = true
	W_wind = false
	if GetBool("savegame.mod.W_wind", true) then
		W_wind = true
	end
	skyrot = false
	default_wetness = GetEnvironmentProperty("wetness")
	default_puddleamount = GetEnvironmentProperty("puddleamount")
	default_puddlesize = GetEnvironmentProperty("puddlesize")
	default_rain = GetEnvironmentProperty("rain")
	default_ambience = GetEnvironmentProperty("ambience")
	default_skyrot = GetEnvironmentProperty("skyboxrot")
-----------------UFOS-------------------------------------
	if GetBool("savegame.mod.VoxelPlazaUFO", true) then
		ufos = FindShapes("ufo", true)
		ufos2 = FindShapes("ufo2", true)
		ufos3 = FindShapes("ufo3", true)
		supports = FindShapes("ufosupport", true)
	end
-----------------STORM----------------------------------
	lightBody = FindBody("thunder", true)
	local s = GetBodyShapes(lightBody)
	lightShape = s[1]
	SetShapeEmissiveScale(lightShape, 0)	
	timer = 0.5
	lightning = 0
	lightningStrength = 0
	thunderSound = LoadSound("thunder0.ogg")
	nextSoundTimer = 0
	nextSound = 0
	nextSoundVolume = 0
	nextSoundTimer = 0
	temp_fix = FindLight("temp_fix", true)
	SetLightEnabled(temp_fix, false)
	if GetBool("savegame.mod.Storm", true) then
		storm = true
	else
		storm = false
	end
---------------TORNADO------------------------------
	tornadoSnd = LoadLoop("tornado.ogg")
	triggers = FindTriggers()
	tornado_ON = false
---------------PERFORMANCE-------------------------
	if GetBool("savegame.mod.performance") then
		lights_on = false
		SetEnvironmentProperty("nightlight", false)
		for i=1,#glasses do
			glass = glasses[i]
			RemoveTag(glass, "nocull")
			Delete(glass)
		end
		for i=1,#lamps do
			lamp = lamps[i]
			SetLightEnabled(lamp, false)
			Delete(lamp)
		end
		Delete(switch)
	end
	delete_ini_shape = FindShape("delete_ini_shape", true)
	Delete(delete_ini_shape)
	hook_shapes = FindShapes("hook", true)
	for i=1,#hook_shapes do
		hook = hook_shapes[i]
		hook_bodies = GetShapeBody(hook)
		ApplyBodyImpulse(hook_bodies)
		ApplyBodyImpulse(hook_bodies, 0,-0.001,0)
	end

end

-------------------------------------------------------------------------------------------------------------------------------------------
--Functions from "scriptingshowcase" MOD and  https://www.teardowngame.com/modding/api.html
-------------------------------------------------------------------------------------------------------------------------------------------

function draw() --Show controls in game
	if menu then
		if InputPressed("b") then
			cinematic = false
			ui = not ui
		end
		if cinematic then
			--Add letterbox black bars at top and bottom
			UiColor(0,0,0)
			UiRect(UiWidth(), 100)
			UiTranslate(0, UiHeight()-90)
			UiRect(UiWidth(), 100)
		end
		if ui then
			if powers_ON and tornado_ON then
				infoBox("Disable Keys:     ".. remap_F8 .." \n\nShow Controls:     B\n\nWeather:     ".. remap_F7 .." \n\nSpawnTornado:     ".. remap_z .." \n\nSpawnFire:     Alt+ ".. remap_mmb .." \n\nMake a Hole:     ".. remap_mmb .." \n\nShield:     ".. remap_q .." \n\nImpulse:     Alt+ ".. remap_q .."")
			elseif not powers_ON and tornado_ON then
				infoBox("Disable Keys:     ".. remap_F8 .." \n\nShow Controls:     B\n\nWeather:     ".. remap_F7 .." \n\nSpawnTornado:     ".. remap_z .."")
			elseif not powers_ON and not tornado_ON then
				infoBox("Disable Keys:     ".. remap_F8 .." \n\nShow Controls:     B\n\nWeather:     ".. remap_F7 .."")
			elseif powers_ON and not tornado_ON then
				infoBox("Disable Keys:     ".. remap_F8 .." \n\nShow Controls:     B\n\nWeather:     ".. remap_F7 .." \n\nSpawnFire:     Alt+ ".. remap_mmb .." \n\nMake a Hole:     ".. remap_mmb .." \n\nShield:     ".. remap_q .." \n\nImpulse:     Alt+ ".. remap_q .."")
			end
			if InputPressed("rmb") then
				ui = false
			end

			UiMakeInteractive()
			UiTranslate(450,130)
			UiColor(0,0,0, 0.7)
			UiImageBox("ui/common/box-solid-10.png", 1050, 950, 10, 10)
			UiTranslate(385,70)
			UiFont("regular.ttf", 32)
			UiColor(0.7,0,1)
			UiText("Press 'B' or 'RMB' to hide")
			UiTranslate(-335, 50)
			UiText("LIGHTS")
			UiTranslate(100, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("º", 100, 50) then
					PlaySound(inputpressed)
					latern = not latern
				end
			UiPop()
			UiTranslate(50, 0)
			UiPush()
				UiTranslate(800,-70)
				UiColor(0,0.8,0.1)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 150, 50) then
					cinematic = not cinematic
					ui = false
				end
				UiTranslate(-25,-35)
				if UiIsMouseInRect(90, 290) then
					UiTranslate(-55,25)
					UiFont("bold.ttf", 16)
					UiText("     Cinematic")
					UiTranslate(0,50)
					UiColor(0, 0.6, 1)
					UiText("     Lightning")
					UiTranslate(0,51)
					UiColor(1, 0.7, 0.2)
					UiText("     Wind")
					UiTranslate(0,50)
					UiColor(0, 0.7, 0.7)
					UiText("     Rain")
					UiTranslate(0,50)
					UiColor(1, 1, 1)
					UiText("     Snow")
					UiTranslate(0,50)
					UiColor(0.1, 0.9, 1)
					UiText("     Wetness")
					UiTranslate(0,-235)
				end
				UiTranslate(25,35)
			UiPop()
			UiTranslate(0, 50)
			UiPush()
				UiTranslate(800,-70)
				UiColor(0, 0.6, 1)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 50, 50) then
					storm = not storm
					if storm then
						SetString("hud.notification", "Lightning ON")
					else
						SetString("hud.notification", "Lightning OFF")
					end
				end
			UiPop()
			UiTranslate(0, 50)
			UiPush()
				UiTranslate(800,-70)
				UiColor(1, 0.7, 0.2)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 50, 50) and w0 then
					PlaySound(inputpressed)
					w0 = false
					w1 = true
					W_wind = true
					SetString("hud.notification", "Wind 1")
					SetEnvironmentProperty("ambience", "outdoor/wind.ogg")
					SetEnvironmentProperty("wind", 0, 1, 5)
				elseif w1 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w1 = false
					w2 = true
					W_wind = true
					SetString("hud.notification", "Wind 2")
					SetEnvironmentProperty("ambience", "outdoor/wind.ogg", 2)
					SetEnvironmentProperty("wind", 0, 2, 20)
				elseif w2 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w2 = false
					w3 = true
					W_wind = true
					SetString("hud.notification", "Wind 3")
					SetEnvironmentProperty("ambience", "outdoor/wind.ogg", 4)
					SetEnvironmentProperty("wind", 0, 4, 45)
				elseif w3 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w3 = false
					w4 = true
					W_wind = true
					SetString("hud.notification", "Wind 4")
					SetEnvironmentProperty("ambience", "outdoor/wind.ogg", 6)
					SetEnvironmentProperty("wind", 0, 10, 70)
				elseif w4 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w4 = false
					w0 = true
					W_wind = false
					SetString("hud.notification", "Wind OFF")
					SetEnvironmentProperty("ambience", default_ambience)
					SetEnvironmentProperty("wind", 0, 0, 0)
				end
			UiPop()
			UiTranslate(0, 50)
			UiPush()
				UiTranslate(800,-70)
				UiColor(0, 0.7, 0.7)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 50, 50) and r0 then
					PlaySound(inputpressed)
					r0 = false
					r1 = true
					SetString("hud.notification", "Rain 1")
					SetEnvironmentProperty("rain", 0.3)
					SetEnvironmentProperty("ambience", "outdoor/rain_light.ogg")
					SetEnvironmentProperty("puddleamount", 0.4)
					SetEnvironmentProperty("puddlesize", 0.8)
					SetEnvironmentProperty("wetness", 0.3)
				elseif r1 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					r1 = false
					r2 = true
					SetString("hud.notification", "Rain 2")
					SetEnvironmentProperty("rain", 0.7)
					SetEnvironmentProperty("ambience", "outdoor/rain_heavy.ogg")
					SetEnvironmentProperty("puddleamount", 0.6)
					SetEnvironmentProperty("puddlesize", 0.8)
					SetEnvironmentProperty("wetness", 0.5)
				elseif r2 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					r2 = false
					r3 = true
					SetString("hud.notification", "Rain Default")
					SetEnvironmentProperty("rain", default_rain)
					SetEnvironmentProperty("ambience", default_ambience)
					SetEnvironmentProperty("puddleamount", default_puddleamount)
					SetEnvironmentProperty("puddlesize", default_puddlesize)
					SetEnvironmentProperty("wetness", default_wetness)
				elseif r3 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					r3 = false
					r0 = true
					SetString("hud.notification", "Rain OFF")
					SetEnvironmentProperty("rain", 0)
					SetEnvironmentProperty("ambience", "outdoor/field.ogg")
					SetEnvironmentProperty("puddleamount", 0)
					SetEnvironmentProperty("puddlesize", 0)
					SetEnvironmentProperty("wetness", 0)
				end
			UiPop()
			UiTranslate(0, 50)
			UiPush()
				UiTranslate(800,-70)
				UiColor(1, 1, 1)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 50, 50) and s0 then
					PlaySound(inputpressed)
					s0 = false
					s1 = true
					SetString("hud.notification", "Snow 1")
					SetEnvironmentProperty("ambience", "outdoor/winter.ogg", 7)
					SetEnvironmentProperty("snowdir", 0, -1, 0, 0.2)
					SetEnvironmentProperty("snowamount", 0.2, 0.05)
				elseif s1 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					s1 = false
					s2 = true
					SetString("hud.notification", "Snow 2")
					SetEnvironmentProperty("ambience", "outdoor/winter.ogg", 7)
					SetEnvironmentProperty("snowdir", 0, -1, 0, 0.2)
					SetEnvironmentProperty("snowamount", 0.4, 0.07)
				elseif s2 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					s2 = false
					s3 = true
					SetString("hud.notification", "Snow 3")
					SetEnvironmentProperty("ambience", "outdoor/winter_snowstorm.ogg")
					SetEnvironmentProperty("snowdir", 0, -1, 4, 0.2)
					SetEnvironmentProperty("snowamount", 0.6, 1)
				elseif s3 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					s3 = false
					s0 = true
					SetString("hud.notification", "Snow OFF")
					SetEnvironmentProperty("ambience", default_ambience)
					SetEnvironmentProperty("snowdir", 0, -1, 0, 0.2)
					SetEnvironmentProperty("snowamount", 0, 0)
				end
			UiPop()
			UiTranslate(0, 50)
			UiPush()
				UiTranslate(800,-70)
				UiColor(0.1, 0.9, 1)
				UiTranslate(0,-1.5)
				UiFont("regular.ttf", 50)
				UiText("-")
				UiTranslate(0,1.5)
				if UiTextButton("=", 50, 50) and w0 then
					PlaySound(inputpressed)
					w0 = false
					w1 = true
					SetString("hud.notification", "Wetness 1")
					SetEnvironmentProperty("wetness", 0)
					SetEnvironmentProperty("puddleamount", 0.4)
					SetEnvironmentProperty("puddlesize", 0.8)
				elseif w1 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w1 = false
					w2 = true
					SetString("hud.notification", "Wetness 2")
					SetEnvironmentProperty("wetness", 1)
					SetEnvironmentProperty("puddleamount", 0)
					SetEnvironmentProperty("puddlesize", 0)
				elseif w2 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w2 = false
					w3 = true
					SetString("hud.notification", "Wetness Default")
					SetEnvironmentProperty("puddleamount", default_puddleamount)
					SetEnvironmentProperty("puddlesize", default_puddlesize)
					SetEnvironmentProperty("wetness", default_wetness)
				elseif w3 and UiTextButton("=", 50, 50) then
					PlaySound(inputpressed)
					w3 = false
					w0 = true
					SetString("hud.notification", "Wetness OFF")
					SetEnvironmentProperty("wetness", 0)
					SetEnvironmentProperty("puddleamount", 0)
					SetEnvironmentProperty("puddlesize", 0)
				end
			UiPop()
			UiTranslate(50, -250)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("1_ON/OFF", 100, 50) then
					PlaySound(inputpressed)
					if GetEnvironmentProperty("nightlight", true) then
						SetEnvironmentProperty("nightlight", false)
					else
						SetEnvironmentProperty("nightlight", true)
					end
				end
			UiPop()
			if not GetBool("savegame.mod.performance") then
				UiTranslate(200, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("2_ON/OFF", 100, 50) then
						PlaySound(inputpressed)
						street_power = not street_power
						for i=1,#lamp_post do
							street = lamp_post[i]
							SetLightEnabled(street, street_power)
						end
					end
				UiPop()
				UiTranslate(200, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("3_ON/OFF", 100, 50) then
						PlaySound(inputpressed)
						lights_on = not lights_on
		
						if not lights_on then
							PlaySound(inputpressed)
							SetTag(switch, "interact", "Turn on")
							for i=1,#glasses do
								glass = glasses[i]
								RemoveTag(glass, "nocull")
							end
							for i=1,#lamps do
								lamp = lamps[i]
								SetLightEnabled(lamp, false)
							end
						elseif lights_on then
							PlaySound(onSound)
							SetTag(switch, "interact", "Turn off")
							for i=1,#glasses do
								glass = glasses[i]
								SetTag(glass, "nocull")
							end
							for i=1,#lamps do
								lamp = lamps[i]
								SetLightEnabled(lamp, true)
							end
						end
					end
				UiPop()
				UiTranslate(130, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("/Delete", 100, 50) then
						PlaySound(inputpressed)
						lights_on = false
						SetString("hud.notification", "Lights Deleted")
						for i=1,#glasses do
							glass = glasses[i]
							RemoveTag(glass, "nocull")
							Delete(glass)
						end
						for i=1,#lamps do
							lamp = lamps[i]
							SetLightEnabled(lamp, false)
							Delete(lamp)
						end
						Delete(switch)
					end
				UiPop()
				UiTranslate(-730, 100)
			else
				UiTranslate(-200, 100)
			end
			UiText("Rotate Skybox")
			UiTranslate(200, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("1", 50, 50) then
					PlaySound(inputpressed)
					actualsky = GetEnvironmentProperty("skyboxrot")
					SetEnvironmentProperty("skyboxrot", actualsky)
					skyrot = true
					skyrot2 = false
					skyrot3 = false
					SetString("hud.notification", "Skyrot 0.3")
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("2", 50, 50) then
					PlaySound(inputpressed)
					actualsky = GetEnvironmentProperty("skyboxrot")
					SetEnvironmentProperty("skyboxrot", actualsky)
					skyrot = false
					skyrot2 = true
					skyrot3 = false
					SetString("hud.notification", "Skyrot 0.5")
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("3", 50, 50) then
					PlaySound(inputpressed)
					actualsky = GetEnvironmentProperty("skyboxrot")
					SetEnvironmentProperty("skyboxrot", actualsky)
					skyrot = false
					skyrot2 = false
					skyrot3 = true
					SetString("hud.notification", "Skyrot 0.9")
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("@", 50, 50) then
					PlaySound(inputpressed)
					SetEnvironmentProperty("skyboxrot", GetTime()*20)
					skyrot = false
					skyrot2 = false
					skyrot3 = false
				end
			UiPop()
			UiTranslate(100, 0)
			UiPush()
				UiColor(1,0,0)
				if UiTextButton("OFF", 50, 50) then
					PlaySound(inputpressed)
					actualsky = GetEnvironmentProperty("skyboxrot")
					SetEnvironmentProperty("skyboxrot", actualsky)
					skyrot = false
					skyrot2 = false
					skyrot3 = false
					SetString("hud.notification", "Skyrot OFF")
				end
			UiPop()

			UiTranslate(-750, 100)
			UiText("Powers")
			UiTranslate(200, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("ENABLE/DISABLE", 50, 50) then
					PlaySound(inputpressed)
					powers_ON = not powers_ON
					if powers_ON then
						SetString("hud.notification", "Powers ON")
					elseif not powers_ON then
						SetString("hud.notification", "Powers OFF")
					end
				end
			UiPop()


			UiTranslate(-200, 100)
			UiText("Tornado")
			UiTranslate(200, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("ENABLE/DISABLE", 50, 50) then
					PlaySound(inputpressed)
					tornado_ON = not tornado_ON
					if tornado_ON then
						SetString("hud.notification", "Tornado ON")
					elseif not tornado_ON then
						SetString("hud.notification", "Tornado OFF")
					end
				end
			UiPop()
			UiTranslate(-200, 100)
			UiText("DELETE")
			UiTranslate(100, 0)
			if not GetBool("savegame.mod.nodemolish") then
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("º", 100, 50) then
						PlaySound(inputpressed)
						Delete(1247)
						Delete(1248)
						Delete(1249)
						Delete(1250)
						Delete(1251)
						Delete(1262)
						Delete(1252)
						Delete(1253)
						Delete(1232)
						Delete(1254)
						Delete(1255)
						Delete(1261)
						Delete(1256)
						Delete(1257)
						Delete(1258)
						Delete(1259)
						Delete(1263)
						Delete(1229)
						Delete(1233)
						Delete(1234)
						Delete(1235)
						Delete(1236)
						Delete(1237)
						Delete(1238)
						Delete(1264)
						Delete(1239)
						Delete(1230)
						Delete(1240)
						Delete(1241)
						Delete(1242)
						Delete(1243)
						Delete(1244)
						Delete(1245)
						Delete(1260)
						Delete(1246)
						Delete(1231)
					end
				UiPop()
			end
			UiTranslate(100, 0)
			UiPush()
				UiColor(1,0,0)
				if UiTextButton("Broken cars", 50, 50) then
					SetString("hud.notification", "Broken Cars Deleted")
					cars = FindBodies("cars", true)
					for i=1,#cars do
						car = cars[i]
						if IsBodyBroken(car) then
							Delete(car)
						end
					end
					ui = false
				end
			UiPop()
			if not GetBool("savegame.mod.performance") then
				UiTranslate(200, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Props", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Props Deleted")
						for i=1,#street_props do
							street_prop = street_props[i]
							Delete(street_prop)
						end
					end
				UiPop()
				UiTranslate(125, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Lamp Posts", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Lamp Posts Deleted")
						for i=1,#lamp_post_body do
							post = lamp_post_body[i]
							Delete(post)
						end
					end
				UiPop()
			else
				UiTranslate(325, 0)
			end
			if GetBool("savegame.mod.robots") then
				UiTranslate(185, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Robots", 50, 50) then
						SetString("hud.notification", "Robots Deleted")
						PlaySound(disableSound)
						SetBool("deleterobots", true)
					end
				UiPop()
				UiTranslate(-185, 0)
			end
			if GetBool("savegame.mod.chopper") then
				if GetBool("savegame.mod.robots") then
					UiTranslate(320, 0)
				else
					UiTranslate(185, 0)
				end
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Chopper", 50, 50) then
						SetBool("delete_chopper", true)
					end
				UiPop()
				if GetBool("savegame.mod.robots") then
					UiTranslate(-320, 0)
				else
					UiTranslate(-185, 0)
				end
			end
			UiTranslate(-525, 100)
			UiText("EXPLOSIVES")
			UiTranslate(200, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("x0.5", 50, 50) then
					QueryRequire("dynamic")
					local explosiveshapes = FindBodies(nil, true)
					PlaySound(inputpressed)
					SetString("hud.notification", "Explosive Props: x0.5")
					explosives = true
					for i=1, #explosiveshapes do
						local s = explosiveshapes[i]
						RemoveTag(explosiveshapes[i], "explosive")
						SetTag(explosiveshapes[i], "explosive", "0.5")
					end
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("x1", 50, 50) then
					QueryRequire("dynamic")
					local explosiveshapes = FindBodies(nil, true)
					PlaySound(inputpressed)
					SetString("hud.notification", "Explosive Props: x1")
					explosives = true
					for i=1, #explosiveshapes do
						local s = explosiveshapes[i]
						RemoveTag(explosiveshapes[i], "explosive")
						SetTag(explosiveshapes[i], "explosive", "1")
					end
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("x2", 50, 50) then
					QueryRequire("dynamic")
					local explosiveshapes = FindBodies(nil, true)
					PlaySound(inputpressed)
					SetString("hud.notification", "Explosive Props: x2")
					explosives = true
					for i=1, #explosiveshapes do
						local s = explosiveshapes[i]
						RemoveTag(explosiveshapes[i], "explosive")
						SetTag(explosiveshapes[i], "explosive", "2.8")
					end
				end
			UiPop()
			UiTranslate(150, 0)
			UiPush()
				UiColor(0,0.8,0.1)
				if UiTextButton("Disable (CTRL+ALT)", 50, 50) then
					QueryRequire("dynamic")
					local explosiveshapes = FindBodies(nil, true)
					PlaySound(inputpressed)
					SetString("hud.notification", "Explosive Props: Disabled")
					explosives = false
					for i=1, #explosiveshapes do
						local s = explosiveshapes[i]
						RemoveTag(explosiveshapes[i], "explosive")
					end
				end
			UiPop()
			if GetBool("savegame.mod.VoxelPlazaUFO", true) then
				UiTranslate(-650, 100)
				UiText("UFO")
				UiTranslate(150, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("Small Attack", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Small Attack")
						for i=1,#ufos3 do
							ufo3 = ufos3[i]
							body = GetShapeBody(ufo3)
							ApplyBodyImpulse(body, Vec(0,0,0), Vec(0,0.01,0))
						end
						ui = false
					end
				UiPop()
				UiTranslate(200, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("Fast Attack", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Fast Attack")
						for i=1,#ufos do
							ufo = ufos[i]
							body = GetShapeBody(ufo)
							ApplyBodyImpulse(body, Vec(0,0,0), Vec(0,0.01,0))
						end
						ui = false
					end
				UiPop()
				UiTranslate(200, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("Heavy Attack", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Heavy Attack")
						for i=1,#ufos2 do
							ufo2 = ufos2[i]
							body = GetShapeBody(ufo2)
							ApplyBodyImpulse(body, Vec(0,0,0), Vec(0,0.01,0))
						end
						ui = false
					end
				UiPop()
				UiTranslate(200, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("One", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "Activated the one you're looking at")
						local t = GetCameraTransform()
						local dir = TransformToParentVec(t, {0, 0, -1})
						local hit, dist4awake = QueryRaycast(t.pos, dir, 2000)
						local pushpos = VecAdd(t.pos, VecScale(dir, dist4awake))
						MakeHole(pushpos, 0.1, 0.1)
						ui = false
					end
				UiPop()
				UiTranslate(100, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Delete", 50, 50) then
						PlaySound(inputpressed)
						SetString("hud.notification", "UFOS DELETED")
						for i=1,#ufos3 do
							ufo3 = ufos3[i]
							body = GetShapeBody(ufo3)
							Delete(body)
						end
						for i=1,#ufos do
							ufo = ufos[i]
							body = GetShapeBody(ufo)
							Delete(body)
						end
						for i=1,#ufos2 do
							ufo2 = ufos2[i]
							body = GetShapeBody(ufo2)
							Delete(body)
						end
						for i=1,#supports do
							support = supports[i]
							body = GetShapeBody(supports)
							Delete(body)
						end
					end
				UiPop()
			UiTranslate(-200, 0)
			end
			if not GetBool("savegame.mod.nodemolish") then
				UiTranslate(-650, 100)
				UiText("Demolition")
				UiTranslate(250, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("A1 /", 50, 50) then
						SetString("hud.notification", "A1")
						Explosion(Vec(25.6, 45.4, 21.8), 0.5)
						MakeHole(Vec(36.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(36.5, 45.4, 12), 3, 3)
						MakeHole(Vec(32.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(32.5, 45.4, 12), 3, 3)
						MakeHole(Vec(28.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(28.5, 45.4, 12), 3, 3)
						MakeHole(Vec(24.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(24.5, 45.4, 12), 3, 3)
						MakeHole(Vec(20.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(20.5, 45.4, 12), 3, 3)
						MakeHole(Vec(16.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(16.5, 45.4, 12), 3, 3)
						MakeHole(Vec(12.5, 45.4, 29.5), 3, 3)
						MakeHole(Vec(12.5, 45.4, 12), 3, 3)
						MakeHole(Vec(36.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(36.5, 41.1, 12), 3, 3)
						MakeHole(Vec(32.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(32.5, 41.1, 12), 3, 3)
						MakeHole(Vec(28.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(28.5, 41.1, 12), 3, 3)
						MakeHole(Vec(24.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(24.5, 41.1, 12), 3, 3)
						MakeHole(Vec(20.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(20.5, 41.1, 12), 3, 3)
						MakeHole(Vec(16.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(16.5, 41.1, 12), 3, 3)
						MakeHole(Vec(12.5, 41.1, 29.5), 3, 3)
						MakeHole(Vec(12.5, 41.1, 12), 3, 3)
						ui = false
					end
				UiPop()
				UiTranslate(50, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("A2 /", 50, 50) then
						SetString("hud.notification", "A2")
						Delete(505)
						MakeHole(Vec(36.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(36.5, 32.5, 12), 3, 3)
						MakeHole(Vec(32.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(32.5, 32.5, 12), 3, 3)
						MakeHole(Vec(28.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(28.5, 32.5, 12), 3, 3)
						MakeHole(Vec(24.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(24.5, 32.5, 12), 3, 3)
						MakeHole(Vec(20.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(20.5, 32.5, 12), 3, 3)
						MakeHole(Vec(16.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(16.5, 32.5, 12), 3, 3)
						MakeHole(Vec(12.5, 32.5, 29.5), 3, 3)
						MakeHole(Vec(12.5, 32.5, 12), 3, 3)
						MakeHole(Vec(36.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(36.5, 23.7, 12), 3, 3)
						MakeHole(Vec(32.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(32.5, 23.7, 12), 3, 3)
						MakeHole(Vec(28.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(28.5, 23.7, 12), 3, 3)
						MakeHole(Vec(24.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(24.5, 23.7, 12), 3, 3)
						MakeHole(Vec(20.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(20.5, 23.7, 12), 3, 3)
						MakeHole(Vec(16.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(16.5, 23.7, 12), 3, 3)
						MakeHole(Vec(16.5, 26.2, 12), 10, 10)
						MakeHole(Vec(12.5, 23.7, 29.5), 3, 3)
						MakeHole(Vec(12.5, 23.7, 12), 3, 3)
						MakeHole(Vec(36.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(36.5, 19.7, 12), 3, 3)
						MakeHole(Vec(32.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(32.5, 19.7, 12), 3, 3)
						MakeHole(Vec(28.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(28.5, 19.7, 12), 3, 3)
						MakeHole(Vec(24.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(24.5, 19.7, 12), 3, 3)
						MakeHole(Vec(20.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(20.5, 19.7, 12), 3, 3)
						MakeHole(Vec(16.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(16.5, 19.7, 12), 3, 3)
						MakeHole(Vec(12.5, 19.7, 29.5), 3, 3)
						MakeHole(Vec(12.5, 19.7, 12), 3, 3)
						MakeHole(Vec(36.5, 11, 29.5), 3, 3)
						MakeHole(Vec(36.5, 11, 12), 3, 3)
						MakeHole(Vec(32.5, 11, 29.5), 3, 3)
						MakeHole(Vec(32.5, 11, 12), 3, 3)
						MakeHole(Vec(28.5, 11, 29.5), 3, 3)
						MakeHole(Vec(28.5, 11, 12), 3, 3)
						MakeHole(Vec(24.5, 11, 29.5), 3, 3)
						MakeHole(Vec(24.5, 11, 12), 3, 3)
						MakeHole(Vec(20.5, 11, 29.5), 3, 3)
						MakeHole(Vec(20.5, 11, 12), 3, 3)
						MakeHole(Vec(16.5, 11, 29.5), 3, 3)
						MakeHole(Vec(16.5, 11, 12), 3, 3)
						MakeHole(Vec(12.5, 11, 29.5), 3, 3)
						MakeHole(Vec(12.5, 11, 12), 3, 3)
						MakeHole(Vec(24.5, 7.2, 24), 5, 5)
						MakeHole(Vec(24.5, 7.2, 18), 5, 5)
						ui = false
					end
				UiPop()
				UiTranslate(50, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("A3", 50, 50) then
						SetString("hud.notification", "A3")
						Explosion(Vec(0.5, 23.9, 55.7), 0.5)
						Explosion(Vec(0.7, 23.9, 39), 0.5)
						MakeHole(Vec(-9, 23.9, 34), 3, 3)
						MakeHole(Vec(9, 23.9, 34), 3, 3)
						MakeHole(Vec(-9, 23.9, 38), 10, 10)
						MakeHole(Vec(9, 23.9, 38), 3, 3)
						MakeHole(Vec(-9, 23.9, 42), 3, 3)
						MakeHole(Vec(9, 23.9, 42), 3, 3)
						MakeHole(Vec(-9, 23.9, 46), 3, 3)
						MakeHole(Vec(9, 23.9, 46), 3, 3)
						MakeHole(Vec(-9, 23.9, 50), 3, 3)
						MakeHole(Vec(9, 23.9, 50), 3, 3)
						MakeHole(Vec(-9, 23.9, 54), 3, 3)
						MakeHole(Vec(9, 23.9, 54), 3, 3)
						MakeHole(Vec(-9, 23.9, 58), 3, 3)
						MakeHole(Vec(9, 23.9, 58), 3, 3)
						MakeHole(Vec(-9, 23.9, 62), 3, 3)
						MakeHole(Vec(9, 23.9, 62), 3, 3)
						MakeHole(Vec(-9, 19.7, 34), 3, 3)
						MakeHole(Vec(9, 19.7, 34), 3, 3)
						MakeHole(Vec(-9, 19.7, 38), 3, 3)
						MakeHole(Vec(9, 19.7, 38), 3, 3)
						MakeHole(Vec(-9, 19.7, 42), 3, 3)
						MakeHole(Vec(9, 19.7, 42), 3, 3)
						MakeHole(Vec(-9, 19.7, 46), 3, 3)
						MakeHole(Vec(9, 19.7, 46), 3, 3)
						MakeHole(Vec(-9, 19.7, 50), 3, 3)
						MakeHole(Vec(9, 19.7, 50), 3, 3)
						MakeHole(Vec(-9, 19.7, 54), 3, 3)
						MakeHole(Vec(9, 19.7, 54), 3, 3)
						MakeHole(Vec(-9, 19.7, 58), 3, 3)
						MakeHole(Vec(9, 19.7, 58), 3, 3)
						MakeHole(Vec(-9, 19.7, 62), 3, 3)
						MakeHole(Vec(9, 19.7, 62), 3, 3)
						MakeHole(Vec(-9, 15.3, 34), 3, 3)
						MakeHole(Vec(9, 15.3, 34), 3, 3)
						MakeHole(Vec(-9, 15.3, 38), 3, 3)
						MakeHole(Vec(9, 15.3, 38), 3, 3)
						MakeHole(Vec(-9, 15.3, 42), 3, 3)
						MakeHole(Vec(9, 15.3, 42), 3, 3)
						MakeHole(Vec(-9, 15.3, 46), 3, 3)
						MakeHole(Vec(9, 15.3, 46), 3, 3)
						MakeHole(Vec(-9, 15.3, 50), 3, 3)
						MakeHole(Vec(9, 15.3, 50), 3, 3)
						MakeHole(Vec(-9, 15.3, 54), 3, 3)
						MakeHole(Vec(9, 15.3, 54), 3, 3)
						MakeHole(Vec(-9, 15.3, 58), 3, 3)
						MakeHole(Vec(9, 15.3, 58), 3, 3)
						MakeHole(Vec(-9, 15.3, 62), 3, 3)
						MakeHole(Vec(9, 15.3, 62), 3, 3)
						MakeHole(Vec(-9, 11, 34), 3, 3)
						MakeHole(Vec(9, 11, 34), 3, 3)
						MakeHole(Vec(-9, 11, 38), 3, 3)
						MakeHole(Vec(9, 11, 38), 3, 3)
						MakeHole(Vec(-9, 11, 42), 3, 3)
						MakeHole(Vec(9, 11, 42), 3, 3)
						MakeHole(Vec(-9, 11, 46), 3, 3)
						MakeHole(Vec(9, 11, 46), 3, 3)
						MakeHole(Vec(-9, 11, 50), 3, 3)
						MakeHole(Vec(9, 11, 50), 3, 3)
						MakeHole(Vec(-9, 11, 54), 3, 3)
						MakeHole(Vec(9, 11, 54), 3, 3)
						MakeHole(Vec(-9, 11, 58), 3, 3)
						MakeHole(Vec(9, 11, 58), 3, 3)
						MakeHole(Vec(-9, 11, 62), 3, 3)
						MakeHole(Vec(9, 11, 62), 3, 3)
						MakeHole(Vec(-4, 7.2, 46), 5, 5)
						MakeHole(Vec(2.5, 7.2, 46), 5, 5)
						ui = false
					end
				UiPop()
				UiTranslate(100, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("B1 /", 50, 50) then
						SetString("hud.notification", "B1")
						Delete(503)
						Delete(499)
						Delete(495)
						MakeHole(Vec(-18, 45.4, 42.7), 2, 2)
						MakeHole(Vec(-8, 28.7, 53.6), 13, 13)
						MakeHole(Vec(-2, 45.4, 53.6), 13, 13)
						MakeHole(Vec(-6, 32.5, 39), 13, 13)
						MakeHole(Vec(0, 41.1, 39), 13, 13)
						MakeHole(Vec(-18, 23.9, 57), 5, 5)
						MakeHole(Vec(-18, 23.9, 53), 3, 3)
						MakeHole(Vec(-18, 23.9, 49), 3, 3)
						MakeHole(Vec(-18, 23.9, 45), 3, 3)
						MakeHole(Vec(-18, 23.9, 41), 3, 3)
						MakeHole(Vec(-18, 23.9, 37), 3, 3)
						MakeHole(Vec(-18, 23.9, 33), 3, 3)
						MakeHole(Vec(-22, 23.9, 33), 3, 3)
						MakeHole(Vec(-26, 23.9, 33), 3, 3)
						MakeHole(Vec(-30, 23.9, 33), 3, 3)
						MakeHole(Vec(-34, 23.9, 33), 3, 3)
						Explosion(Vec(-24, 45.4, 36.5), 0.5)
						Explosion(Vec(-23.7, 45.4, 54.8), 0.5)
						Explosion(Vec(-16.6, 41.1, 50), 0.5)
						Explosion(Vec(-38, 24.7, 34), 2)
						Explosion(Vec(-38, 24.7, 53.3), 2)
						Explosion(Vec(-33.3, 24.7, 58), 2)
						Explosion(Vec(-14, 27.4, 58.5), 0.8)
						Explosion(Vec(-14, 27.4, 34), 0.8)
						ui = false
					end
				UiPop()
				UiTranslate(50, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("B2", 50, 50) then
						SetString("hud.notification", "B2")
						MakeHole(Vec(11.9, 44.7, -13), 10, 10)
						MakeHole(Vec(11.9, 44.7, -6), 10, 10)
						MakeHole(Vec(11.9, 44.7, 0), 10, 10)
						MakeHole(Vec(5, 44.7, 0), 10, 10)
						MakeHole(Vec(-2, 44.7, 0), 10, 10)
						MakeHole(Vec(-9, 44.7, 0), 10, 10)
						MakeHole(Vec(-11, 46.2, 0), 10, 10)
						MakeHole(Vec(11.9, 41.1, -13), 10, 10)
						MakeHole(Vec(11.9, 41.1, -6), 10, 10)
						MakeHole(Vec(11.9, 41.1, 0), 10, 10)
						MakeHole(Vec(5, 41.1, 0), 10, 10)
						MakeHole(Vec(-2, 41.1, 0), 10, 10)
						MakeHole(Vec(-9, 41.1, 0), 10, 10)
						MakeHole(Vec(-11, 42.2, 0), 10, 10)
						MakeHole(Vec(11.9, 36.7, -13), 10, 10)
						MakeHole(Vec(11.9, 36.7, -6), 10, 10)
						MakeHole(Vec(11.9, 36.7, 0), 10, 10)
						MakeHole(Vec(5, 36.7, 0), 10, 10)
						MakeHole(Vec(-2, 36.7, 0), 10, 10)
						MakeHole(Vec(-9, 36.7, 0), 10, 10)
						MakeHole(Vec(-11, 38.2, 0), 10, 10)
						Explosion(Vec(-12.8, 47.7, 7.2), 0.8)
						Explosion(Vec(11.9, 47.7, 7.2), 0.8)
						Explosion(Vec(-8, 46.7, -17), 2)
						Explosion(Vec(-12.8, 46.7, -11), 2)
						Explosion(Vec(11.9, 46.7, -17), 2)
						Explosion(Vec(-8, 41.7, -17), 2)
						Explosion(Vec(-12.8, 41.7, -11), 2)
						Explosion(Vec(11.9, 41.7, -17), 2)
						Explosion(Vec(-8, 37.7, -17), 2)
						Explosion(Vec(-12.8, 37.7, -11), 2)
						Explosion(Vec(11.9, 37.7, -17), 2)
						Explosion(Vec(-8, 31.7, -17), 2)
						Explosion(Vec(11.5, 31.7, -17), 2)
						ui = false
					end
				UiPop()
				UiTranslate(100, 0)
				UiPush()
					UiColor(1,0,0)
					if UiTextButton("Modify  I", 50, 50) and con0 then
						PlaySound(inputpressed)
						con0 = false
						con1 = true
						SetString("hud.notification", "Modify 1")
						Delete(553)
						Delete(561)
						Delete(566)
						Delete(571)
						Delete(578)
						Delete(553)
						Delete(503)
						Delete(1096)
						Delete(1092)
						Delete(1094)
						Delete(1098)
						Delete(556)
						Delete(970)
						Delete(968)
						Delete(369)
						Delete(141)
						Delete(364)
						Delete(506)
						Delete(140)
						Delete(361)
						Delete(139)
						Delete(360)
						Delete(138)
						Delete(370)
						Delete(371)
						Delete(372)
						Delete(142)
						Delete(561)
						Delete(1090)
						Delete(1088)
						Delete(1084)
						Delete(1086)
						Delete(562)
						Delete(964)
						Delete(966)
						Delete(394)
						Delete(159)
						Delete(385)
						Delete(511)
						Delete(158)
						Delete(382)
						Delete(157)
						Delete(381)
						Delete(156)
						Delete(392)
						Delete(390)
						Delete(391)
						Delete(160)
						Delete(566)
						Delete(1082)
						Delete(1080)
						Delete(1078)
						Delete(1076)
						Delete(412)
						Delete(177)
						Delete(405)
						Delete(592)
						Delete(513)
						Delete(176)
						Delete(402)
						Delete(175)
						Delete(401)
						Delete(174)
						Delete(411)
						Delete(607)
						Delete(178)
						Delete(571)
						Delete(1070)
						Delete(1068)
						Delete(1072)
						Delete(1074)
						Delete(572)
						Delete(962)
						Delete(958)
						Delete(428)
						Delete(195)
						Delete(423)
						Delete(515)
						Delete(194)
						Delete(420)
						Delete(193)
						Delete(419)
						Delete(192)
						Delete(431)
						Delete(429)
						Delete(430)
						Delete(196)
						Delete(591)
						Delete(212)
						Delete(452)
						Delete(213)
						Delete(443)
						Delete(211)
						Delete(440)
						Delete(214)
						Delete(439)
						Delete(210)
						Delete(448)
						Delete(449)
						Delete(577)
						Delete(1102)
						Delete(1100)
						Delete(1106)
						Delete(1104)
						Delete(605)
						Delete(606)
						Delete(960)
						Delete(956)
						Delete(451)
						Delete(596)
						ui = false
					elseif con1 and UiTextButton("Modify  II", 50, 50) then
						PlaySound(inputpressed)
						con1 = false
						con2 = true
						SetString("hud.notification", "Modify 2")
						Delete(554)
						Delete(932)
						Delete(938)
						Delete(934)
						Delete(936)
						Delete(505)
						Delete(137)
						Delete(359)
						Delete(507)
						Delete(135)
						Delete(357)
						Delete(134)
						Delete(355)
						Delete(133)
						Delete(374)
						Delete(136)
						Delete(373)
						Delete(609)
						Delete(608)
						Delete(610)
						Delete(559)
						Delete(846)
						Delete(848)
						Delete(832)
						Delete(850)
						Delete(560)
						Delete(842)
						Delete(844)
						Delete(840)
						Delete(838)
						Delete(834)
						Delete(836)
						Delete(393)
						Delete(155)
						Delete(380)
						Delete(509)
						Delete(153)
						Delete(378)
						Delete(152)
						Delete(375)
						Delete(151)
						Delete(376)
						Delete(389)
						Delete(154)
						Delete(565)
						Delete(918)
						Delete(922)
						Delete(916)
						Delete(920)
						Delete(410)
						Delete(173)
						Delete(400)
						Delete(512)
						Delete(171)
						Delete(398)
						Delete(170)
						Delete(395)
						Delete(169)
						Delete(396)
						Delete(172)
						Delete(569)
						Delete(874)
						Delete(878)
						Delete(860)
						Delete(876)
						Delete(570)
						Delete(872)
						Delete(870)
						Delete(866)
						Delete(868)
						Delete(864)
						Delete(862)
						Delete(432)
						Delete(191)
						Delete(418)
						Delete(514)
						Delete(189)
						Delete(416)
						Delete(188)
						Delete(413)
						Delete(187)
						Delete(414)
						Delete(427)
						Delete(190)
						Delete(597)
						Delete(888)
						Delete(906)
						Delete(902)
						Delete(904)
						Delete(576)
						Delete(898)
						Delete(900)
						Delete(896)
						Delete(894)
						Delete(890)
						Delete(892)
						Delete(575)
						Delete(446)
						Delete(208)
						Delete(450)
						Delete(209)
						Delete(438)
						Delete(207)
						Delete(436)
						Delete(206)
						Delete(433)
						Delete(205)
						Delete(434)
						ui = false
					elseif con2 and UiTextButton("Modify  III", 50, 50) then
						PlaySound(inputpressed)
						con2 = false
						SetString("hud.notification", "Modify 3")
						Delete(555)
						Delete(504)
						Delete(928)
						Delete(924)
						Delete(926)
						Delete(930)
						Delete(132)
						Delete(356)
						Delete(131)
						Delete(358)
						Delete(130)
						Delete(362)
						Delete(508)
						Delete(368)
						Delete(558)
						Delete(830)
						Delete(828)
						Delete(824)
						Delete(826)
						Delete(150)
						Delete(377)
						Delete(149)
						Delete(379)
						Delete(148)
						Delete(383)
						Delete(510)
						Delete(564)
						Delete(912)
						Delete(914)
						Delete(908)
						Delete(910)
						Delete(409)
						Delete(168)
						Delete(397)
						Delete(167)
						Delete(399)
						Delete(166)
						Delete(403)
						Delete(568)
						Delete(852)
						Delete(854)
						Delete(858)
						Delete(856)
						Delete(186)
						Delete(415)
						Delete(185)
						Delete(417)
						Delete(184)
						Delete(421)
						Delete(574)
						Delete(884)
						Delete(880)
						Delete(882)
						Delete(886)
						Delete(197)
						Delete(435)
						Delete(198)
						Delete(437)
						Delete(199)
						Delete(441)
						Delete(557)
						Delete(700)
						Delete(702)
						Delete(704)
						Delete(706)
						Delete(128)
						Delete(363)
						Delete(127)
						Delete(365)
						Delete(125)
						Delete(366)
						Delete(126)
						Delete(367)
						Delete(129)
						Delete(563)
						Delete(694)
						Delete(692)
						Delete(696)
						Delete(698)
						Delete(146)
						Delete(384)
						Delete(145)
						Delete(386)
						Delete(143)
						Delete(387)
						Delete(144)
						Delete(388)
						Delete(147)
						Delete(567)
						Delete(686)
						Delete(684)
						Delete(688)
						Delete(690)
						Delete(164)
						Delete(404)
						Delete(163)
						Delete(406)
						Delete(161)
						Delete(407)
						Delete(162)
						Delete(408)
						Delete(165)
						Delete(573)
						Delete(678)
						Delete(676)
						Delete(680)
						Delete(682)
						Delete(182)
						Delete(422)
						Delete(181)
						Delete(424)
						Delete(179)
						Delete(425)
						Delete(180)
						Delete(426)
						Delete(183)
						Delete(579)
						Delete(670)
						Delete(668)
						Delete(672)
						Delete(674)
						Delete(203)
						Delete(442)
						Delete(202)
						Delete(444)
						Delete(200)
						Delete(445)
						Delete(201)
						Delete(447)
						Delete(204)
						Delete(580)
						Delete(662)
						Delete(660)
						Delete(664)
						Delete(666)
						Delete(456)
						Delete(218)
						Delete(454)
						Delete(217)
						Delete(453)
						Delete(215)
						Delete(455)
						Delete(216)
						Delete(457)
						Delete(219)
						Delete(581)
						Delete(652)
						Delete(654)
						Delete(656)
						Delete(658)
						Delete(461)
						Delete(223)
						Delete(459)
						Delete(222)
						Delete(458)
						Delete(220)
						Delete(460)
						Delete(221)
						Delete(462)
						Delete(224)
						Delete(582)
						Delete(644)
						Delete(646)
						Delete(650)
						Delete(648)
						Delete(466)
						Delete(228)
						Delete(464)
						Delete(227)
						Delete(463)
						Delete(225)
						Delete(465)
						Delete(226)
						Delete(467)
						Delete(229)
						Delete(583)
						Delete(638)
						Delete(636)
						Delete(640)
						Delete(642)
						Delete(471)
						Delete(233)
						Delete(469)
						Delete(232)
						Delete(468)
						Delete(230)
						Delete(470)
						Delete(231)
						Delete(472)
						Delete(234)
						Delete(584)
						Delete(628)
						Delete(630)
						Delete(632)
						Delete(634)
						Delete(476)
						Delete(238)
						Delete(599)
						Delete(474)
						Delete(237)
						Delete(473)
						Delete(235)
						Delete(475)
						Delete(236)
						Delete(477)
						Delete(239)
						Delete(589)
						Delete(604)
						Delete(599)
						Delete(585)
						Delete(622)
						Delete(620)
						Delete(624)
						Delete(626)
						Delete(481)
						Delete(242)
						Delete(479)
						Delete(240)
						Delete(478)
						Delete(244)
						Delete(480)
						Delete(243)
						Delete(482)
						Delete(241)
						ui = false
					end
				UiPop()
				UiTranslate(-600, 100)
				UiText("Spawn")
				UiTranslate(100, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("1", 50, 50) then
						clean = FindShapes("remove_4", true)
						for i=1, #clean do
							local s = clean[i]
							Delete(s)
						end
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(-40.7, 2.4, 36), QuatEuler(0, -1.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("2", 50, 50) then
						clean = FindShapes("remove_5", true)
						for i=1, #clean do
							local s = clean[i]
							Delete(s)
						end
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(26, 2.4, 60.6), QuatEuler(0, 88.95, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("3", 50, 50) then
						clean = FindShapes("remove_1", true)
						for i=1, #clean do
							local s = clean[i]
							Delete(s)
						end
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(39.2, 2.4, 44.5), QuatEuler(0, 178.95, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("4", 50, 50) then
						clean = FindShapes("remove_2", true)
						for i=1, #clean do
							local s = clean[i]
							Delete(s)
						end
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(39.2, 2.4, -3), QuatEuler(0, 178.95, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("5", 50, 50) then
						clean = FindShapes("remove_3", true)
						for i=1, #clean do
							local s = clean[i]
							Delete(s)
						end
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(25.3, 2.4, -19.2), QuatEuler(0, -91.05, 0)))
					end
				UiPop()
				UiTranslate(50, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("1", 50, 50) then
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(35.5, 45.4, 3.5), QuatEuler(0, -181.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("2", 50, 50) then
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(35.5, 45.4, 33), QuatEuler(0, -181.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("3", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(26.5, 45.4, -15.9), QuatEuler(0, -91.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("4", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(13.7, 45.4, -8.5), QuatEuler(0, -181.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("5", 50, 50) then
						Spawn("MOD/instances/scaffold_big.xml", Transform(Vec(24.4, 45.4, 13.0), QuatEuler(0, -1.05, 0)))
					end
				UiPop()
				UiTranslate(27, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("6", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(8.5, 23.9, 46), QuatEuler(0, -91.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("7", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(-10, 23.9, 46.2), QuatEuler(0, -269.95, 0)))
					end
				UiPop()
				UiTranslate(27, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("8", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(-18, 23.9, 32), QuatEuler(0, -91.05, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("9", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(-30.6, 23.9, 12), QuatEuler(0, -1.05, 0)))
					end
				UiPop()
				UiTranslate(50, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("1", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(80.4, 33.9, 10.6), QuatEuler(0, -179.95, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("2", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(75.1, 34.3, 40), QuatEuler(0, 89.95, 0)))
					end
				UiPop()
				UiTranslate(25, 0)
				UiPush()
					UiColor(0,0.8,0.1)
					if UiTextButton("3", 50, 50) then
						Spawn("MOD/instances/scaffold_small.xml", Transform(Vec(-12.6, 26.9, -50.4), QuatEuler(0, -181, 0)))
					end
				UiPop()
				UiTranslate(690, -100)
			end
			UiTranslate(-650, 100)
			UiPush()
				UiColor(1,0,0)
				if UiTextButton("Components", 50, 50) then
					interiors = FindShapes("interiors", true)
					for i=1, #interiors do
						local s = interiors[i]
						Delete(s)
					end
					vp_interiors_2 = FindShapes("vp_interiors_2", true)
					for i=1, #vp_interiors_2 do
						local s = vp_interiors_2[i]
						Delete(s)
					end
				end
			UiPop()
			UiTranslate(170, 0)
			UiPush()
				UiColor(1,0,0)
				if UiTextButton("Buildings / Islands", 50, 50) then
					SetBool("disable_waterfall", true)
					B_doors = FindShapes("B_doors", true)
					for i=1, #B_doors do
						local s2 = B_doors[i]
						Delete(s2)
					end
					build = FindBodies("B_notdynamic", true)
					for i=1, #build do
						local s = build[i]
						Delete(s)
					end
					build_2 = FindBodies("B_notdynamic_C", true)
					for i=1, #build_2 do
						local s = build_2[i]
						Delete(s)
					end
					notdynamic = FindBodies("notdynamic", true)
					van_S = FindVehicles("van_S", true)
					pickup_S = FindVehicles("pickup_S", true)
					castanet_S = FindVehicles("castanet_S", true)
					racingcar_S = FindVehicles("racingcar_S", true)
					dumptruck_S = FindVehicles("dumptruck_S", true)
					sportcar_S = FindVehicles("sportcar_S", true)
					truck_S = FindVehicles("truck_S", true)
					musclecar_S = FindVehicles("musclecar_S", true)
					end_track = FindTriggers("end_track", true)
					turbo = FindTriggers("turbo", true)
					slow = FindTriggers("slow", true)
					reset = FindLocations("reset", true)
					supports = FindBodies("supports", true)
					road_segment = FindShapes("road_segment", true)
					for i=1, #truck_S do
						local s = truck_S[i]
						Delete(s)
					end
					for i=1, #musclecar_S do
						local s = musclecar_S[i]
						Delete(s)
					end
					for i=1, #van_S do
						local s = van_S[i]
						Delete(s)
					end
					for i=1, #pickup_S do
						local s = pickup_S[i]
						Delete(s)
					end
					for i=1, #castanet_S do
						local s = castanet_S[i]
						Delete(s)
					end
					for i=1, #racingcar_S do
						local s = racingcar_S[i]
						Delete(s)
					end
					for i=1, #dumptruck_S do
						local s = dumptruck_S[i]
						Delete(s)
					end
					for i=1, #sportcar_S do
						local s = sportcar_S[i]
						Delete(s)
					end
					for i=1, #end_track do
						local s = end_track[i]
						Delete(s)
					end
					for i=1, #turbo do
						local s = turbo[i]
						Delete(s)
					end
					for i=1, #slow do
						local s = slow[i]
						Delete(s)
					end
					for i=1, #reset do
						local s = reset[i]
						Delete(s)
					end
					for i=1, #road_segment do
						local s = road_segment[i]
						Delete(s)
					end
					for i=1, #notdynamic do
						local s = notdynamic[i]
						Delete(s)
					end
					for i=1, #supports do
						local s = supports[i]
						Delete(s)
					end
				end
			UiPop()
			UiTranslate(-370, 75)
			UiFont("bold.ttf", 24)
			UiColor(0, 0.8, 0.1)
			UiText("Graphics: Ultra")
			UiColor(1, 1, 1)
			UiTranslate(-30, 0)
			if UiIsMouseInRect(200, 25) then
				UiFont("bold.ttf", 20)
				UiTranslate(-360, 80)
				UiText("///Abient light/ocluder///, ///Skybox light///, ///Constant light///, ///Sun legth/Fog scale///, ///Fog scale///, ///Wetness///")
				UiTranslate(360, -80)
			end
			UiFont("bold.ttf", 26)
			UiTranslate(15, 25)
			UiButtonImageBox("ui/common/box-outline-6.png", 6, 6, 0.6, 0.6, 0.6)
			UiPush()
				if not GetBool("savegame.mod.ultra") then
					UiTranslate(-12, -20)
					UiPush()
						UiColor(0.5, 1, 0.5, 0.5)
						UiImageBox("ui/common/box-solid-6.png", 100, 25, 6, 6)
					UiPop()
					UiTranslate(12, 20)
				end
				if UiTextButton("Disable", 100, 25) then
					PlaySound(inputpressed)
					SetBool("savegame.mod.ultra", false)
					SetString("hud.notification", "Next Weather in: Default")
				end
				UiTranslate(100, 0)
				if GetBool("savegame.mod.ultra") then
					UiTranslate(-15, -20)
					UiPush()
						UiColor(0.5, 1, 0.5, 0.5)
						UiImageBox("ui/common/box-solid-6.png", 100, 25, 6, 6)
					UiPop()
					UiTranslate(15, 20)
				end
				if UiTextButton("Enable", 100, 25) then 
					PlaySound(inputpressed)
					SetBool("savegame.mod.ultra", true)
					SetString("hud.notification", "Next Weather in: Ultra")
				end
			UiPop()
		end
	end
end


--ForceField--Return random number between mi and ma
function rnd(mi, ma)
	return math.random()*(ma-mi)+mi
end


--ForceField--Limit linear and angular velocity of a dynamic body
function limitVelocity(body, lin, ang)
	local linVel = GetBodyVelocity(body)
	local linVelLength = VecLength(linVel)
	if linVelLength > lin then 
		linVel = VecScale(linVel, lin/linVelLength)
		SetBodyVelocity(body, linVel)
	end
	
	local angVel = GetBodyAngularVelocity(body)
	local angVelLength = VecLength(angVel)
	if angVelLength > ang then 
		angVel = VecScale(angVel, ang/angVelLength)
		SetBodyAngularVelocity(body, angVel)
	end
end

---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------

function tick(dt)
	if PauseMenuButton("Voxel Plaza") then
		if not menu then
			SetString("hud.notification", "             Keys On\nPress  ".. remap_F8 .."  to disable")
		end
		ui = true
		menu = true
	elseif InputPressed("esc") then
		ui = false
	end
	--Keys On/Off
	if InputPressed(remap_F8) and menu then
		PlaySound(inputpressed)
		menu = not menu
		SetString("hud.notification", "Keys Off")
	else
		if InputPressed(remap_F8) and not menu then
			PlaySound(inputpressed)
			menu = not menu
			SetString("hud.notification", "                                            Keys On\nPause Menu or Press  'B'  to show the controls")
		end
	end

	if menu then

		if latern then
			PointLight(GetPlayerPos(), 0.9, 0.4, 0.2, 7)
		end

	--DisableExplosives--
		if InputDown("Ctrl") then
			if InputPressed("Alt") and explosives then
				QueryRequire("dynamic")
				local explosiveshapes = FindBodies(nil, true)
				PlaySound(inputpressed)
				SetString("hud.notification", "Explosive Props: Disabled")
				explosives = false
				for i=1, #explosiveshapes do
					local s = explosiveshapes[i]
					RemoveTag(explosiveshapes[i], "explosive")
				end
			end
		end
		if explosives and GetFloat("game.player.health") == 0 then
			QueryRequire("dynamic")
			local explosiveshapes = FindBodies(nil, true)
			explosives = false
			for i=1, #explosiveshapes do
				local s = explosiveshapes[i]
				RemoveTag(explosiveshapes[i], "explosive")
				SetString("hud.notification", "Explosive Props: Disabled")
			end
		end
		if powers_ON then
			--ForceField--
			local strength = 90000
			local maxDist = 7.5
	
			if InputPressed(remap_q) then
				force = not force
			end
	
			if force then
				playerforcepos = VecAdd(GetPlayerTransform().pos, Vec(0,-1,0))
				QueryRequire("dynamic")
				local aabbMin = VecAdd(playerforcepos, Vec(-maxDist, 0, -maxDist))
				local aabbMax = VecAdd(playerforcepos, Vec(maxDist, maxDist, maxDist))
				local shapes = QueryAabbShapes(aabbMin, aabbMax)
				for i=1, #shapes do
					local s = shapes[i]
					local hit, cp = GetShapeClosestPoint(s, playerforcepos)
				
					local d = VecSub(cp, playerforcepos)
					local l = VecLength(d)
			
					--Scale factor based on distance to fan
					local scale = 1.0-l/maxDist
					
					--Create an upwards impulse
					local imp = Vec(0, strength*scale, 0)
				
					--Apply impulse to the shape's body 
					local b = GetShapeBody(s)
					ApplyBodyImpulse(b, cp, imp)
					
					--This is a bit of a hack (but quite useful method) to avoid dynamic 
					--bodies to spin out of control
					limitVelocity(b, 0.4, 0.4)	
				end
			end
	
		
			if InputDown("Alt") then
				if InputDown(remap_q) then
					force =false
					playerforcepos = VecAdd(GetPlayerTransform().pos, Vec(0,-1,0))
					QueryRequire("dynamic")
					local aabbMin = VecAdd(playerforcepos, Vec(-maxDist, 0, -maxDist))
					local aabbMax = VecAdd(playerforcepos, Vec(maxDist, 60, maxDist))
					local shapes = QueryAabbShapes(aabbMin, aabbMax)
					for i=1, #shapes do
						local s = shapes[i]
						local hit, cp = GetShapeClosestPoint(s, playerforcepos)
					
						local d = VecSub(cp, playerforcepos)
						local l = VecLength(d)
			
						--Scale factor based on distance to fan
						local scale = 5.0-l/maxDist
						
						--Create an upwards impulse
						local imp = Vec(0, strength*scale, 0)
					
						--Apply impulse to the shape's body 
						local b = GetShapeBody(s)
						ApplyBodyImpulse(b, cp, imp)
						
						--This is a bit of a hack (but quite useful method) to avoid dynamic 
						--bodies to spin out of control
						limitVelocity(b, 20, 20)		
					end
				end
			end
	
	
			--Fire/Hole--
			if InputDown("Alt") then
				if InputDown(remap_mmb) then
					local t = GetCameraTransform()
					local dir = TransformToParentVec(t, {0, 0, -1})
					local hit, dist4fire = QueryRaycast(t.pos, dir, 30)
					local firepos = VecAdd(t.pos, VecScale(dir, dist4fire))
					SpawnFire(firepos)
					PointLight(firepos, 0.9, 0.4, 0.2, 7)
					Paint(firepos, 0.5, "explosion")
				end
			end
			if not InputDown("Alt") then
				if InputDown(remap_mmb) then
					local t = GetCameraTransform()
					local dir = TransformToParentVec(t, {0, 0, -1})
					local hit, dist4fire = QueryRaycast(t.pos, dir, 30)
					local firepos = VecAdd(t.pos, VecScale(dir, dist4fire))
					MakeHole(firepos, 10, 10, 0, true)
				end
			end
		end

---------------------------------------------------------------------------------------------------------------------------


	--Weather--
		if skyrot then
			--Rotate skybox continuously
			SetEnvironmentProperty("skyboxrot", GetTime()*0.3)
		elseif skyrot2 then
			SetEnvironmentProperty("skyboxrot", GetTime()*0.5)
		elseif skyrot3 then
			SetEnvironmentProperty("skyboxrot", GetTime()*0.9)
		end

		if InputPressed(remap_z) and tornado_ON and not tornado.active then
			PlaySound(inputpressed)
			SetString("hud.notification", "Tornado")
			spawnTornado()
		elseif InputPressed(remap_z) and tornado_ON and tornado.active then
			PlaySound(inputpressed)
			SetString("hud.notification", "Tornado OFF")
			tornado.active = false
		end
		if InputPressed(remap_F7) and DeadLight then
			PlaySound(inputpressed)
			DeadLight = false
			sunrise = true
			SetEnvironmentProperty("skybox", "sunset.dds")
			SetEnvironmentProperty("skyboxtint", 0.88,0.44,0.26)
			SetEnvironmentProperty("skyboxbrightness", 0.8)
			SetEnvironmentProperty("sunBrightness", 4)
			SetEnvironmentProperty("skyboxrot", 180)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("fogColor", 1,1,1)
			SetEnvironmentProperty("fogParams", 0,0,0,0)
			SetEnvironmentProperty("sunColorTint", 0.5,0.4,0.3)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Sunrise: Ultra")
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("fogscale", 0.4)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunFogScale", 0.7)
			else
				SetString("hud.notification", "Sunrise")
				SetEnvironmentProperty("ambient", 1)
				SetEnvironmentProperty("sunLength", 17)
				SetEnvironmentProperty("fogscale", 0.2)
				SetEnvironmentProperty("ambientexponent", 0.9)
				SetEnvironmentProperty("sunFogScale", 0.4)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 3,5)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg")
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and sunrise then
			PlaySound(inputpressed)
			sunrise = false
			sunny = true
			SetEnvironmentProperty("skybox", "day.dds")
			SetEnvironmentProperty("skyboxtint", 1,1,0.9)
			SetEnvironmentProperty("skyboxrot", 30)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("fogColor", 0.2,0.21,0.22)
			SetEnvironmentProperty("fogParams", 250,400,1,9)
			SetEnvironmentProperty("sunBrightness", 4)
			SetEnvironmentProperty("sunFogScale", 0.18)
			SetEnvironmentProperty("sunColorTint", 0.92,0.74,0.6)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Sunny: Ultra")
				SetEnvironmentProperty("skyboxbrightness", 0.4)
				SetEnvironmentProperty("ambient", 1.5)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("sunFogScale", 0.18)
				SetEnvironmentProperty("fogscale", 0.3)
				SetEnvironmentProperty("ambientexponent", 1.3)
			else
				SetString("hud.notification", "Sunny")
				SetEnvironmentProperty("skyboxbrightness", 0.8)
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("sunLength", 17)
				SetEnvironmentProperty("sunFogScale", 0)
				SetEnvironmentProperty("fogscale", 0)
				SetEnvironmentProperty("ambientexponent", 0.7)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 3,3)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg")
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 0.97)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and sunny then
			PlaySound(inputpressed)
			sunny = false
			sunset = true
			SetEnvironmentProperty("skybox", "sunset.dds")
			SetEnvironmentProperty("skyboxtint", 0.8,0.3,0.14)
			SetEnvironmentProperty("skyboxbrightness", 0.8)
			SetEnvironmentProperty("constant", 0.001,0.003,0.002)
			SetEnvironmentProperty("skyboxrot", -15)
			SetEnvironmentProperty("ambient", 0.5)
			SetEnvironmentProperty("fogColor", 1,1,1)
			SetEnvironmentProperty("fogParams", 0,0,0,0)
			SetEnvironmentProperty("sunBrightness", 4)
			SetEnvironmentProperty("sunColorTint", 0.57,0.48,0.3)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Sunset: Ultra")
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("fogscale", 0.4)
				SetEnvironmentProperty("sunFogScale", 0.8)
			else
				SetString("hud.notification", "Sunset")
				SetEnvironmentProperty("ambientexponent", 0.5)
				SetEnvironmentProperty("sunLength", 17)
				SetEnvironmentProperty("fogscale", 0.2)
				SetEnvironmentProperty("sunFogScale", 0)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 5,5)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg")
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and sunset then
			PlaySound(inputpressed)
			sunset = false
			night = true
			SetEnvironmentProperty("skybox", "cloudy.dds")
			SetEnvironmentProperty("skyboxtint", 1,0.5,0.2)
			SetEnvironmentProperty("skyboxbrightness", 0)
			SetEnvironmentProperty("skyboxrot", 0)
			SetEnvironmentProperty("ambient", 0)
			SetEnvironmentProperty("fogColor", 1,1,1)
			SetEnvironmentProperty("fogParams", 0,0,0,0)
			SetEnvironmentProperty("sunBrightness", 0)
			SetEnvironmentProperty("sunColorTint", 1,1,1)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			SetEnvironmentProperty("sunLength", 0)
			SetEnvironmentProperty("sunFogScale", 0)
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 7,7)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", true)
			SetEnvironmentProperty("ambience", "outdoor/night.ogg")
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Night: Ultra")
				SetEnvironmentProperty("constant", 0.001,0.001,0.001)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("fogscale", 0.4)
			else
				SetString("hud.notification", "Night")
				SetEnvironmentProperty("constant", 0.003,0.003,0.003)
				SetEnvironmentProperty("ambientexponent", 0.7)
				SetEnvironmentProperty("fogscale", 0.2)
			end
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and night then
			PlaySound(inputpressed)
			night = false
			nightstorm = true
			storm = true
			SetEnvironmentProperty("skybox", "cloudy.dds")
			SetEnvironmentProperty("skyboxtint", 1,0.5,0.2)
			SetEnvironmentProperty("skyboxbrightness", 0)
			SetEnvironmentProperty("skyboxrot", 0)
			SetEnvironmentProperty("ambient", 0)
			SetEnvironmentProperty("fogColor", 1,1,1)
			SetEnvironmentProperty("fogParams", 0,0,0,0)
			SetEnvironmentProperty("sunBrightness", 0)
			SetEnvironmentProperty("sunColorTint", 1,1,1)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			SetEnvironmentProperty("sunLength", 0)
			SetEnvironmentProperty("sunFogScale", 0)
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 7,7)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0.3)
			SetEnvironmentProperty("puddleamount", 0.4)
			SetEnvironmentProperty("puddlesize", 0.8)
			SetEnvironmentProperty("rain", 0.3)
			SetEnvironmentProperty("nightlight", true)
			SetEnvironmentProperty("ambience", "outdoor/rain_heavy.ogg")
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Storm: Ultra")
				SetEnvironmentProperty("constant", 0.001,0.001,0.001)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("fogscale", 0.6)
			else
				SetString("hud.notification", "Storm")
				SetEnvironmentProperty("constant", 0.003,0.003,0.003)
				SetEnvironmentProperty("ambientexponent", 0.7)
				SetEnvironmentProperty("fogscale", 0.4)
			end
			SetEnvironmentProperty("slippery", 0.2)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and nightstorm then
			PlaySound(inputpressed)
			nightstorm = false
			storm = false
			foggy = true
			SetEnvironmentProperty("skybox", "cloudy.dds")
			SetEnvironmentProperty("skyboxtint", 1,1,1)
			SetEnvironmentProperty("skyboxbrightness", 0)
			SetEnvironmentProperty("skyboxrot", 0)
			SetEnvironmentProperty("constant", 0.002,0.002,0.002)
			SetEnvironmentProperty("ambient", 0)
			SetEnvironmentProperty("fogColor", 0.2,0.2,0.2)
			SetEnvironmentProperty("fogParams", 0,27,1,0)
			SetEnvironmentProperty("sunBrightness", 0)
			SetEnvironmentProperty("sunColorTint", 1,1,1)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			SetEnvironmentProperty("sunLength", 0)
			SetEnvironmentProperty("sunFogScale", 0)
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 2,3)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg")
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Foggy: Ultra")
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("fogscale", 3)
				SetEnvironmentProperty("wetness", 0.3)
				SetEnvironmentProperty("puddleamount", 0.4)
				SetEnvironmentProperty("puddlesize", 0.8)
			else
				SetString("hud.notification", "Foggy")
				SetEnvironmentProperty("ambientexponent", 0.3)
				SetEnvironmentProperty("fogscale", 0.5)
				SetEnvironmentProperty("wetness", 0.0)
				SetEnvironmentProperty("puddleamount", 0.0)
				SetEnvironmentProperty("puddlesize", 0.0)
			end
			SetEnvironmentProperty("slippery", 0.2)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and foggy then
			PlaySound(inputpressed)
			foggy = false
			rain = true
			SetEnvironmentProperty("skybox", "sunset.dds")
			SetEnvironmentProperty("skyboxtint", 1,0.6,0.4)
			SetEnvironmentProperty("skyboxrot", -30)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("ambient", 0.8)
			SetEnvironmentProperty("fogColor", 0.8,0.4,0.2)
			SetEnvironmentProperty("fogParams", 0,220,0.6,0)
			SetEnvironmentProperty("sunColorTint", 0.54,0.5,1)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 0,4)
			SetEnvironmentProperty("brightness", 1.3)
			SetEnvironmentProperty("puddleamount", 0.4)
			SetEnvironmentProperty("puddlesize", 0.8)
			SetEnvironmentProperty("rain", 0.3)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/rain_light.ogg")
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Rain: Ultra")
				SetEnvironmentProperty("skyboxbrightness", 0.4)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunBrightness", 2)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("sunFogScale", 0.7)
				SetEnvironmentProperty("fogscale", 0.8)
				SetEnvironmentProperty("wetness", 0.3)
			else
				SetString("hud.notification", "Rain")
				SetEnvironmentProperty("skyboxbrightness", 0.8)
				SetEnvironmentProperty("ambientexponent", 0.9)
				SetEnvironmentProperty("sunBrightness", 0)
				SetEnvironmentProperty("sunLength", 0)
				SetEnvironmentProperty("sunFogScale", 0)
				SetEnvironmentProperty("fogscale", 0.2)
				SetEnvironmentProperty("wetness", 0)
			end
			SetEnvironmentProperty("slippery", 0.2)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and rain then
			PlaySound(inputpressed)
			rain = false
			snow = true
			SetEnvironmentProperty("skybox", "cold_wispy_sky.dds")
			SetEnvironmentProperty("skyboxtint", 0.2,0.6,1)
			SetEnvironmentProperty("skyboxbrightness", 0.1)
			SetEnvironmentProperty("skyboxrot", 110)
			SetEnvironmentProperty("constant", 0.008,0.004,0.012)
			SetEnvironmentProperty("fogColor", 0.035,0.0625,0.2)
			SetEnvironmentProperty("fogParams", 0,70,1,1.3)
			SetEnvironmentProperty("sunBrightness", 4)
			SetEnvironmentProperty("sunColorTint", 0.7,0.4,0.6)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Snow: Ultra")
				SetEnvironmentProperty("ambient", 0.7)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("sunFogScale", 0.7)
				SetEnvironmentProperty("fogscale", 0.8)
				SetEnvironmentProperty("wetness", 0.4)
			else
				SetString("hud.notification", "Snow")
				SetEnvironmentProperty("ambient", 1.7)
				SetEnvironmentProperty("ambientexponent", 0.5)
				SetEnvironmentProperty("sunLength", 20)
				SetEnvironmentProperty("sunFogScale", 0.4)
				SetEnvironmentProperty("fogscale", 0.3)
				SetEnvironmentProperty("wetness", 0)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 4,4)
			SetEnvironmentProperty("brightness", 0.5)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", true)
			SetEnvironmentProperty("ambience", "winter.ogg", 5)
			SetEnvironmentProperty("slippery", 0.2)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, -1, 0, 0.2)
			SetEnvironmentProperty("snowamount", 0.2, 0.05)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and snow then
			PlaySound(inputpressed)
			snow = false
			wind = true
			SetEnvironmentProperty("skybox", "tornado.dds")
			SetEnvironmentProperty("skyboxtint", 1,0.3,0.15)
			SetEnvironmentProperty("skyboxbrightness", 0.4)
			SetEnvironmentProperty("skyboxrot", -15)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("fogColor", 0.04,0.004,0)
			SetEnvironmentProperty("fogParams", 40,180,1,1)
			SetEnvironmentProperty("sunBrightness", 2)
			SetEnvironmentProperty("sunColorTint", 0.63,0.5,0.2)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Wind: Ultra")
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunFogScale", 0.6)
				SetEnvironmentProperty("fogscale", 0.8)
			else
				SetString("hud.notification", "Wind")
				SetEnvironmentProperty("ambient", 1)
				SetEnvironmentProperty("sunLength", 10)
				SetEnvironmentProperty("ambientexponent", 0.7)
				SetEnvironmentProperty("sunFogScale", 0)
				SetEnvironmentProperty("fogscale", 0.3)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 2,2)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("puddleamount", 0)
			SetEnvironmentProperty("puddlesize", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/wind.ogg")
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 1, 5)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = true
		elseif InputPressed(remap_F7) and wind then
			PlaySound(inputpressed)
			wind = false
			dark_sunset = true
			SetEnvironmentProperty("skybox", "sunset_in_the_chalk_quarry_2k.dds")
			SetEnvironmentProperty("skyboxtint", 0.7,0.5,0.7)
			SetEnvironmentProperty("skyboxbrightness", 0.02)
			SetEnvironmentProperty("ambientexponent", 0.5)
			SetEnvironmentProperty("skyboxrot", -15)
			SetEnvironmentProperty("fogColor", 0,0,0)
			SetEnvironmentProperty("fogParams", 0,0,0,0)
			SetEnvironmentProperty("sunBrightness", 35)
			SetEnvironmentProperty("sunColorTint", 0.48,0.5,0.3)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Dark Sunset: Ultra")
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("constant", 0.001,0.001,0.001)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("sunFogScale", 0.2)
				SetEnvironmentProperty("fogscale", 0.4)
				SetEnvironmentProperty("wetness", 0.4)
				SetEnvironmentProperty("puddleamount", 0.5)
				SetEnvironmentProperty("puddlesize", 0.8)
			else
				SetString("hud.notification", "Dark Sunset")
				SetEnvironmentProperty("ambient", 1)
				SetEnvironmentProperty("constant", 0.003,0.003,0.003)
				SetEnvironmentProperty("sunLength", 20)
				SetEnvironmentProperty("sunFogScale", 0)
				SetEnvironmentProperty("fogscale", 0.2)
				SetEnvironmentProperty("wetness", 0.4)
				SetEnvironmentProperty("puddleamount", 0)
				SetEnvironmentProperty("puddlesize", 0)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 7,7)
			SetEnvironmentProperty("brightness", 1)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg", 1)
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0.5, 2)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and dark_sunset then
			PlaySound(inputpressed)
			dark_sunset = false
			SA_sunset = true
			SetEnvironmentProperty("skybox", "sunset.dds")
			SetEnvironmentProperty("skyboxtint", 0.56,0.23,0.4)
			SetEnvironmentProperty("skyboxbrightness", 0.4)
			SetEnvironmentProperty("skyboxrot", 280)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("fogColor", 0.4,0.035,0.003)
			SetEnvironmentProperty("fogParams", 0,87,0.86,1.2)
			SetEnvironmentProperty("sunBrightness", 6)
			SetEnvironmentProperty("sunColorTint", 0.56,0.4,0)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "S.A Sunset: Ultra")
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("sunFogScale", 0.6)
				SetEnvironmentProperty("fogscale", 0.5)
				SetEnvironmentProperty("puddleamount", 0.4)
				SetEnvironmentProperty("puddlesize", 0.8)
			else
				SetString("hud.notification", "S.A Sunset")
				SetEnvironmentProperty("ambient", 1.0)
				SetEnvironmentProperty("ambientexponent", 0.7)
				SetEnvironmentProperty("sunLength", 20)
				SetEnvironmentProperty("sunFogScale", 0.4)
				SetEnvironmentProperty("fogscale", 0.2)
				SetEnvironmentProperty("puddleamount", 0)
				SetEnvironmentProperty("puddlesize", 0)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 5,5)
			SetEnvironmentProperty("brightness", 0.5)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/field.ogg", 1)
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, 0, 0, 0)
			SetEnvironmentProperty("snowamount", 0, 0)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		elseif InputPressed(remap_F7) and SA_sunset then
			PlaySound(inputpressed)
			SA_sunset = false
			DeadLight = true
			SetEnvironmentProperty("skybox", "cool_day.dds")
			SetEnvironmentProperty("skyboxtint", 0.42,0.8,0.19)
			SetEnvironmentProperty("skyboxbrightness", 0.04)
			SetEnvironmentProperty("skyboxrot", 115)
			SetEnvironmentProperty("constant", 0.003,0.003,0.003)
			SetEnvironmentProperty("fogColor", 0.19,0.4,0.13)
			SetEnvironmentProperty("fogParams", 0,47,0.95,0)
			SetEnvironmentProperty("sunBrightness", 80)
			SetEnvironmentProperty("sunColorTint", 0.9,0.497,0.8)
			SetEnvironmentProperty("sunDir", "auto")
			SetEnvironmentProperty("sunSpread", 0)
			if GetBool("savegame.mod.ultra") then
				SetString("hud.notification", "Dead Light: Ultra")
				SetEnvironmentProperty("ambient", 0.8)
				SetEnvironmentProperty("sunLength", 32)
				SetEnvironmentProperty("ambientexponent", 1.3)
				SetEnvironmentProperty("sunFogScale", 0.7)
				SetEnvironmentProperty("puddleamount", 0.4)
				SetEnvironmentProperty("puddlesize", 0.8)
				SetEnvironmentProperty("fogscale", 0.5)
			else
				SetString("hud.notification", "Dead Light")
				SetEnvironmentProperty("ambient", 1)
				SetEnvironmentProperty("sunLength", 20)
				SetEnvironmentProperty("ambientexponent", 0.9)
				SetEnvironmentProperty("sunFogScale", 0.4)
				SetEnvironmentProperty("puddleamount", 0)
				SetEnvironmentProperty("puddlesize", 0)
				SetEnvironmentProperty("fogscale", 0.2)
			end
			SetEnvironmentProperty("sunGlare", 0)
			SetEnvironmentProperty("exposure", 2,2)
			SetEnvironmentProperty("brightness", 0.4)
			SetEnvironmentProperty("wetness", 0)
			SetEnvironmentProperty("rain", 0)
			SetEnvironmentProperty("nightlight", false)
			SetEnvironmentProperty("ambience", "outdoor/winter.ogg", 0)
			SetEnvironmentProperty("slippery", 0)
			SetEnvironmentProperty("wind", 0, 0, 0)
			SetEnvironmentProperty("waterhurt", 0)
			SetEnvironmentProperty("snowdir", 0, -1, 0, 0.2)
			SetEnvironmentProperty("snowamount", 0.2, 0.03)
			SetPostProcessingProperty("saturation" , 1)
			SetPostProcessingProperty("colorbalance" , 1, 1, 1)
			SetPostProcessingProperty("brightness" , 1)
			SetPostProcessingProperty("gamma" , 1)
			SetPostProcessingProperty("bloom" , 1)
			r0 = true
			r1 = false
			r2 = false
			r3 = false
			s0 = true
			s1 = false
			s2 = false
			s3 = false
			w0 = true
			w1 = false
			w2 = false
			w3 = false
			w4 = false
			wt0 = true
			wt1 = false
			wt2 = false
			wt3 = false
			W_wind = false
		end
	end
	if storm then
		if not GetBool("game.map.enabled") then
			timer = timer - dt
		end
		if timer <= 0 then
			lightning = math.random(2, 5)*0.1
			lightningStrength = 0
			local x = math.random(-150, 150)
			local y = 80
			local z = math.random(-150, 150)
			SetBodyTransform(lightBody, Transform(Vec(x, y, z)))
			nextSoundVolume = 0.5 + math.random(1, 5)*0.1
			nextSoundTimer = 0.5 + math.random(1, 10)*0.1
			timer = math.random(3, 10)
		end
	
		if nextSoundTimer > 0 then
			nextSoundTimer = nextSoundTimer - dt
			if nextSoundTimer <= 0 then
				PlaySound(thunderSound, GetPlayerPos(), nextSoundVolume)
			end
		end
		
		if lightning > 0 then
			lightning = lightning - dt
			lightningStrength = clamp(lightningStrength + math.random(-10,10)*0.1, 0.1, 1.0)
		end
	
		if lightning > 0 then
			SetShapeEmissiveScale(lightShape, lightningStrength)	
		else
			SetShapeEmissiveScale(lightShape, 0)
			SetBodyTransform(lightBody, Transform(Vec(0, -500, 0)))
		end
	end
	if foggy then
		SetShapeEmissiveScale(lightShape, 0)
		SetBodyTransform(lightBody, Transform(Vec(0, -500, 0)))
	end
end
---------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------

function infoBox(txt)
	UiPush()
		UiFont("regular.ttf", 22)
		UiWordWrap(900)

		local w,h = UiGetTextSize(txt)
		UiTranslate(20-600*(1-visible), UiHeight()-h-80)
		UiColor(0,0,0, 0.7)
		UiImageBox("ui/common/box-solid-10.png", w+40, h+30, 10, 10)
		UiTranslate(20, 35)
		
		UiColor(1,1,1)
		UiText(txt)
	UiPop()
end

local MIN_RADIUS = 0.8
local MAX_RADIUS = 21
local ROT_SPEED = 8
local HEIGHT = 90
local MIN_SPAWN_DIST_TO_PLAYER = 4

local SUCK_RADIUS = 21

function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function rndVec(t)
	return Vec(rnd(-t, t), rnd(-t, t), rnd(-t, t))
end

tornado = {}
tornado.pos = Vec()
tornado.age = 0
tornado.lifetime = 0
tornado.spawnAngle = 0
tornado.active = false


function spawn(startPos, endPos, lifetime)
	tornado.startPos = startPos
	tornado.endPos = endPos
	tornado.age = 0
	tornado.lifetime = 55
	tornado.spawnAngle = 0
	tornado.pos = startPos
	tornado.active = true
end



function mix(lo, hi, t)
	return lo+(hi-lo)*t
end

function getOffset(relativeHeight)
	local bigAng = tornado.age * 1 + relativeHeight*8
	local bend = math.sin(relativeHeight*math.pi) * 3 -- Bend only in the middle
	return Vec(math.sin(bigAng)*bend, 0, math.sin(bigAng*0.7)*bend)
end

function emitParticles()
	ParticleReset()
	ParticleType("plain")
	ParticleTile(0)
	ParticleCollide(0)
	local count = 64
	tornado.spawnAngle = tornado.spawnAngle + 2.39996
	local spawnAngle = tornado.spawnAngle
	for i=0, count do
		local hh = i/count
		hh = hh * hh * hh * hh -- Need to spawn more particles at bottom
		local q = 1.0-hh
		local h = HEIGHT * hh
		spawnAngle = spawnAngle + 2.39996 --Golden angle
		local ang =  spawnAngle
		local r = mix(MIN_RADIUS, MAX_RADIUS, hh*hh) * rnd(0.7, 1.3)
		local v = ROT_SPEED
		local lifetime = 2/(v/r)

		--Position and velocity
		local pos = VecAdd(tornado.pos, Vec(math.cos(ang)*r, h, math.sin(ang)*r))
		local offset = getOffset(hh)
		pos = VecAdd(pos, offset)
		local vel = Vec(-math.sin(ang)*v, v*q, math.cos(ang)*v)

		--Particle properties
		local col = rnd(0.7, 1.0)
		ParticleColor(0.33, 0.30, 0.27)
		ParticleRadius(0.6 + r*0.6)
		ParticleAlpha(q*tornado.amount, 0, "constant", 0.25, 0.5)

		--Spawn
		SpawnParticle(pos, vel, lifetime)
	end
	ParticleReset()
	ParticleCollide(0)
	ParticleType("smoke")
	ParticleAlpha(tornado.amount, 0)
	ParticleTile(0)
	ParticleColor(0.43, 0.4, 0.37)
	ParticleDrag(0.4)
	for i=1, 4 do
		ParticleRadius(20, rnd(0.3, 0.6))
		SpawnParticle(VecAdd(tornado.pos, Vec(rnd(-0.2, 0.2), rnd(0.1, 0.2), rnd(-0.2, 0.2))), Vec(rnd(-10, 10), rnd(-2, 2), rnd(-10, 10)), rnd(1.0, 3.0))
	end
	ParticleReset()
	ParticleType("plain")
	ParticleAlpha(tornado.amount, 0)
	ParticleTile(6)
	ParticleColor(0.4, 0.4, 0.4)
	ParticleDrag(0.05)
	ParticleCollide(1.0)
	for i=1,4 do
		ParticleGravity(-10)
		ParticleRadius(rnd(0.01, 0.03))
		SpawnParticle(VecAdd(tornado.pos, rndVec(0.1)), Vec(rnd(-5,5), rnd(2, 10), rnd(-5,5)), rnd(0.5, 1.5))
	end
end

function destroy()
	local h = rnd(0.0, 8.0)
	local pos = VecAdd(tornado.pos, getOffset(h/HEIGHT))
	pos[2] = pos[2] + h
	MakeHole(pos, 2, 3, 0, true)
end

function getVelForBody(pos, mass, vel, angVel)
	--Closest point on tornado
	local tornadoPoint = VecCopy(tornado.pos)
	tornadoPoint[2] = pos[2]
	local tornadoHeight = clamp((tornadoPoint[2] - tornado.pos[2])/HEIGHT, 0.0, 1.0)
	tornadoPoint = VecAdd(tornadoPoint, getOffset(tornadoHeight))
	
	local toTornado = VecSub(tornadoPoint, pos)
	local dist = VecLength(toTornado)
	if dist > 0.0 then
		toTornado = VecScale(toTornado, 1.0 / dist)
	end
	
	if dist < SUCK_RADIUS then
		local strength = 1.0 - dist/SUCK_RADIUS
		strength = strength * (1-tornadoHeight) 
		strength = strength * strength
		strength = strength * 3.0 * tornado.amount
		strength = strength * 1500 / (1000+mass)
		
		local addVel = VecScale(toTornado, strength)
		addVel[2] = strength * 0.5
		local perp = Vec(toTornado[3], 0.0, -toTornado[1])
		addVel = VecAdd(addVel, VecScale(perp, strength*0.2))
		local maxVel = 8
		
		for i=1, 3 do
			if addVel[i] < 0 and vel[i] < -maxVel then addVel[i]=0 end
			if addVel[i] > 0 and vel[i] > maxVel then addVel[i]=0 end
		end

		local maxAngVel = 5
		local addAngVel = -ROT_SPEED * strength * 0.05
		if angVel[2] < -maxAngVel then addAngVel = 0 end
		return VecAdd(vel, addVel), VecAdd(angVel, Vec(0, addAngVel, 0))
	else 
		return vel, angVel
	end
end

function suction()
	local lo = VecAdd(tornado.pos, Vec(-SUCK_RADIUS, 0, -SUCK_RADIUS))
	local hi = VecAdd(tornado.pos, Vec(SUCK_RADIUS, HEIGHT, SUCK_RADIUS))
	QueryRequire("dynamic")
	local bodies = QueryAabbBodies(lo, hi)
	for i=1, #bodies do
		local body = bodies[i]
		local bodyPos = TransformToParentPoint(GetBodyTransform(body), GetBodyCenterOfMass(body))
		local vel, angVel = getVelForBody(bodyPos, GetBodyMass(body), GetBodyVelocity(body), GetBodyAngularVelocity(body))
		SetBodyVelocity(body, vel)
		SetBodyAngularVelocity(body, angVel)
	end

	--Affect player
	if GetPlayerVehicle() == 0 and not GetBool("game.map.enabled") then
		local ppos = GetPlayerTransform().pos
		ppos[2] = ppos[2] + 1.0 -- Chest height
		local tpos = VecCopy(tornado.pos)
		tpos[2] = ppos[2]		-- Same height on tornado
		local diff = VecSub(tpos, ppos)
		local length = VecLength(diff)
		if length > 0 and length < SUCK_RADIUS then
			local toTornado = VecScale(diff, 1.0/length)
			QueryRequire("static")
			local hit = QueryRaycast(ppos, toTornado, length)
			if not hit then
				if length < 3 then
					ReleasePlayerGrab()
				end
			
				ShakeCamera(1.0 - length/SUCK_RADIUS)

				--Make player approach tornado when on ground
				local strength = math.pow(1.0 - length / SUCK_RADIUS, 0.5) * 8.0 * tornado.amount;
				SetPlayerGroundVelocity(VecScale(toTornado, strength))

				--Modify player velocity
				local vel = getVelForBody(ppos, 2000, GetPlayerVelocity(), Vec())
				SetPlayerVelocity(vel)
			end
		end
	end
end

function spawnTornadoInTrigger(trigger)
	local mi, ma = GetTriggerBounds(trigger)
	local p1, p2

	local minDist = math.max(ma[1]-mi[1], ma[3]-mi[3])*0.25
	minDist = math.min(minDist, 5.0)

	for i=1, 100 do
		local probe = Vec()
		for j=1, 3 do
			probe[j] = mi[j] + (ma[j]-mi[j])*rnd(0,1)
		end
		if IsPointInTrigger(trigger, probe) then
			local ppos = GetPlayerTransform().pos
			ppos[2] = probe[2]
			if not p1 and VecLength(VecSub(probe, ppos)) > MIN_SPAWN_DIST_TO_PLAYER then
				p1 = probe
				p1[2] = mi[2]
			else
				if VecLength(VecSub(probe, p1)) > minDist then
					p2 = probe
					p2[2] = mi[2]
					break
				end
			end
		end
	end
	if p1 and p2 then
		spawn(p1, p2, 10)
	end
end

function spawnTornado()
	local ppos = TransformToParentPoint(GetPlayerTransform(), Vec(0, 0, -16))
	DebugCross(ppos)
	ppos[2] = 0
	local bestLength = 1000000
	local bestTrigger = nil
	for i=1, #triggers do
		local mi, ma = GetTriggerBounds(triggers[i])
		local pos = VecLerp(mi, ma, 0.5)
		pos[2] = 0
		local l = VecLength(VecSub(ppos, pos))
		if l<bestLength then
			bestLength = l
			bestTrigger = triggers[i]
		end
	end
	if bestTrigger then
		spawnTornadoInTrigger(bestTrigger)
	end
end

function getParticlePos(rMin, rMax, life)
	local camPos = GetCameraTransform().pos
	local p = rndVec(1)
	p[2] = 0
	local d = rnd(rMin, rMax)
	p = VecScale(VecNormalize(p), d)
	p = VecAdd(p, camPos)
	p = VecSub(p, VecScale(GetWindVelocity(p), life * 0.5))
	p[2] = 20;
	local hit, dist = QueryRaycast(p, Vec(0,-1,0), 20)
	if not hit then dist = 20 end
	p[2] = math.max(p[2] - dist, 1)
	p[2] = p[2] + rnd(0, 2)
	return p, d
end

gLargeParticles = 4
gSmallParticles = 2
gSmokeParticles = 24
gParticleColor = {0.3, 0.25, 0.2}
gSmokeColor = {0.7, 0.65, 0.6}

function update(dt)
	if tornado.active then
		tornado.pos = VecLerp(tornado.startPos, tornado.endPos, tornado.age/tornado.lifetime)
		local fadeIn = 2.0
		local fadeOut = 2.0
		if tornado.age < fadeIn	then 
			tornado.amount = tornado.age/fadeIn
		elseif tornado.lifetime-tornado.age < fadeOut then
			tornado.amount = (tornado.lifetime-tornado.age)/fadeOut
		else
			tornado.amount = 1.0
		end
		PlayLoop(tornadoSnd, tornado.pos, tornado.amount * 3)
	
		tornado.pos[1] = tornado.pos[1] + 0.03
		tornado.pos[3] = tornado.pos[3] + 0.03
		--destroy()
		suction()
		emitParticles()
	
		tornado.age = tornado.age + dt
		if tornado.age > tornado.lifetime then
			tornado.active = false
		end
	end
-----------Winddust---------------------------------------------
	ParticleReset()
	ParticleType("plain")
	ParticleRadius(0.8)
	ParticleColor(gParticleColor[1], gParticleColor[2], gParticleColor[3])
	ParticleAlpha(1, 1, "constant", 0.5, 0.5)
	ParticleCollide(0)
	ParticleTile(8)
	if W_wind then
		for i = 1, gLargeParticles do
			local life = 1.0
			local p, d = getParticlePos(8, 12, life);
			local vel = GetWindVelocity(p);
			SpawnParticle(p, vel, life)
		end
	end
	
	ParticleReset()
	ParticleType("plain")
	ParticleRadius(0.02)
	ParticleGravity(-5)
	ParticleColor(gParticleColor[1], gParticleColor[2], gParticleColor[3])
	ParticleAlpha(1, 1, "constant", 0.5, 0.5)
	ParticleCollide(1)
	ParticleTile(4)
	if W_wind then
		for i = 1, gSmallParticles do
			local life = 1.0
			local p, d = getParticlePos(6, 10, life);
			local vel = GetWindVelocity(p);
			SpawnParticle(p, vel, life)
		end
	end

	ParticleReset()
	ParticleType("plain")
	ParticleGravity(-5)
	ParticleColor(gSmokeColor[1], gSmokeColor[2], gSmokeColor[3])
	ParticleAlpha(0.1, 0.1, "constant", 0.5, 0.5)
	ParticleCollide(1)
	ParticleTile(0)
	if W_wind then
		for i = 1, gSmokeParticles do
			local life = 1.0
			local p, d = getParticlePos(8, 32, life);
			local vel = GetWindVelocity(p);
			ParticleRadius(d/10)
			SpawnParticle(p, vel, life)
		end
	end
end