wormholeSpawn = 0
wormholeTimer = 0
function rnd(mi, ma)
	return math.random()*(ma-mi)+mi
end
function init()	
	--Find handles to the light switch and and lamp
	switch = FindShape("switch")
	glasses = FindShapes("glass", true)
	lamps = FindLights("lamp")


	--The light should start turned off

	on = false

	for i=1,#lamps do
		lamp = lamps[i]
		SetLightEnabled(lamp, false)
	end

	SetTag(switch, "interact", "Turn on")

	for i=1,#glasses do
		glass = glasses[i]
		SetLightEnabled(lamp, false)
		RemoveTag(glass, "nocull")
	end

	--Load sounds from the game asset folder (data/snd)
	onSound = LoadSound("screen-on.ogg")
	offSound = LoadSound("screen-off.ogg")
	wormhole = LoadSound("../../data/snd/submerged.ogg")
	wormholeButton = FindShape("wormhole")
	SetTag(wormholeButton, "interact")
	wormholePos = GetLocationTransform(FindLocation("wormhole_pos")).pos
	buttonSound = LoadSound("clickdown.ogg")
	spawn_1 = true
end


function tick(dt)
	--Check if player interacts with light switch and presses interact button
	if GetPlayerInteractShape() == switch and InputPressed("interact") then

		--Turn light on or off, depending on the current state
		if on then
			on = false
			PlaySound(offSound)
			SetTag(switch, "interact", "Turn on")

			for i=1,#glasses do
				glass = glasses[i]
				RemoveTag(glass, "nocull")
			end
			for i=1,#lamps do
				lamp = lamps[i]
				SetLightEnabled(lamp, false)
			end
		else
			on = true
			PlaySound(onSound)
			SetTag(switch, "interact", "Turn off")
			for i=1,#glasses do
				glass = glasses[i]
				SetTag(glass, "nocull")
			end
			for i=1,#lamps do
				lamp = lamps[i]
				SetLightEnabled(lamp, true)
			end
		end
	end

	if IsShapeBroken(switch) then
		for i=1,#glasses do
			glass = glasses[i]
			SetLightEnabled(lamp, false)
			RemoveTag(glass, "nocull")
			Delete(lamp)
			Delete(glass)
		end
	end

	if GetPlayerInteractShape() == wormholeButton and InputPressed("interact") then
		PlaySound(wormhole)
		wormholeSpawn = 50
		wormholeTimer = 0
		if spawn_1 then
			xml = "<body dynamic='true'><vox file='../../data/vox/tool/steroid.vox'/></body>"
			spawn_1 = false
			spawn_2 = true
			spawn_3 = false
			spawn_4 = false
		elseif spawn_2 then
			xml = "<body dynamic='true'><vox file='../../mods/assetpack/assets/props/pylone.vox'/></body>"
			spawn_1 = false
			spawn_2 = false
			spawn_3 = true
			spawn_4 = false
		elseif spawn_3 then
			xml = "<body dynamic='true'><vox file='../../mods/scriptingshowcase/vox/banana.vox'/></body>"
			spawn_1 = false
			spawn_2 = false
			spawn_3 = false
			spawn_4 = true
		elseif spawn_4 then
			xml = "<body dynamic='true'><vox file='../../mods/proppack/prop/items/plasticcan-lee.vox'/></body>"
			spawn_1 = true
			spawn_2 = false
			spawn_3 = false
			spawn_4 = false
		end
	end
	if wormholeSpawn > 0 then
		wormholeTimer = math.max(wormholeTimer - dt, 0)
		if wormholeTimer == 0 then
			local entities = Spawn(xml, Transform(wormholePos))
			local vel = Vec(rnd(-2, 2), rnd(-4, -8), rnd(-2, 2))
			for i=1, #entities do
				if GetEntityType(entities[i]) == "body" then
					SetBodyVelocity(entities[i], vel)
					SetBodyAngularVelocity(entities[i], Vec(rnd(-3,3), rnd(-3,3), rnd(-3,3)))
				end
			end
			wormholeSpawn = wormholeSpawn - 1
			wormholeTimer = 0.1
		end
	end	
end