function init()
	B_notdynamic_C = FindBody("B_notdynamic_C")
	SetBodyDynamic(B_notdynamic_C, false)
	view = FindShape("view", true)
	breakground = FindShapes("breakground")
	lights=FindLights("night")
	disable = false
	inputpressed = LoadSound("warning-beep.ogg")

	if not GetString("savegame.mod.remap_rmb_spawn") then
		SetString("savegame.mod.remap_rmb_spawn", "rmb")
	end
	remap_rmb_spawn = GetString("savegame.mod.remap_rmb_spawn")

	if not GetString("savegame.mod.remap_x_spawn") then
		SetString("savegame.mod.remap_x_spawn", "x")
	end
	remap_x_spawn = GetString("savegame.mod.remap_x_spawn")

	if not GetString("savegame.mod.remap_c_spawn") then
		SetString("savegame.mod.remap_c_spawn", "c")
	end
	remap_c_spawn = GetString("savegame.mod.remap_c_spawn")
end


function tick()
	if not disable then
		if InputDown(remap_rmb_spawn)then
			if not unbreakable then
				SetString("hud.notification", "______________________________\n\nHold '".. remap_rmb_spawn .."' to allow dynamic enviroment\n\n            Press '".. remap_x_spawn .."' to delete components\n\n           Press '".. remap_c_spawn .."' to make it unbreakable\n\n                          KeyBind: 'Alt' + 'G'\n\n           *Breakable*              *Allow Dynamic*")
			else
				SetString("hud.notification", "______________________________\n\nHold '".. remap_rmb_spawn .."' to allow dynamic enviroment\n\n            Press '".. remap_x_spawn .."' to delete components\n\n           Press '".. remap_c_spawn .."' to make it unbreakable\n\n                          KeyBind: 'Alt' + 'G'\n\n           *Unbreakable*        *Allow Dynamic*")
			end
			allow_dynamic = true
		else
			if not unbreakable then
				SetString("hud.notification", "______________________________\n\nHold '".. remap_rmb_spawn .."' to allow dynamic enviroment\n\n            Press '".. remap_x_spawn .."' to delete components\n\n           Press '".. remap_c_spawn .."' to make it unbreakable\n\n                          KeyBind: 'Alt' + 'G'\n\n           *Breakable*              *Force Static*")
			else
				SetString("hud.notification", "______________________________\n\nHold '".. remap_rmb_spawn .."' to allow dynamic enviroment\n\n            Press '".. remap_x_spawn .."' to delete components\n\n           Press '".. remap_c_spawn .."' to make it unbreakable\n\n                          KeyBind: 'Alt' + 'G'\n\n           *Unbreakable*          *Force Static*")
			end
			allow_dynamic = false
		end

		if InputPressed(remap_x_spawn)then
			PlaySound(inputpressed)
			interiors = FindShapes("interiors")
			for i=1, #interiors do
				local s = interiors[i]
				Delete(s)
			end
		end


		if InputPressed(remap_c_spawn)then
			PlaySound(inputpressed)
			unbreakable = not unbreakable
			if unbreakable then
				for i=1, #breakground do
					local bg = breakground[i]
					SetTag(bg, "unbreakable")
				end
			else
				for i=1, #breakground do
					local bg = breakground[i]
					RemoveTag(bg, "unbreakable")
				end
			end
		end

		if InputPressed("lmb")then
			if not remap_keys then
				if allow_dynamic then
					local min, max = GetBodyBounds(B_notdynamic_C)
					QueryRequire("dynamic")
					list = QueryAabbShapes(min, max)
					for i=1, #list do
						props = list[i]
						props_body = GetShapeBody(props)
						SetBodyDynamic(props_body, true)
					end
				else
					local min, max = GetBodyBounds(B_notdynamic_C)
					QueryRequire("dynamic")
					list = QueryAabbShapes(min, max)
					for i=1, #list do
						props = list[i]
						props_body = GetShapeBody(props)
						SetBodyDynamic(props_body, false)
					end
				end
				B_notdynamic_C = 0
				Delete(view)
				if not GetEnvironmentProperty("nightlight", true) then
					for i=1, #lights do
						local Ln = lights[i]
						SetLightEnabled(Ln, false)
					end
				end
				disable = true
			end
		end
	end
end


function draw()
	if not disable then
		if InputDown("alt") and InputPressed("g") then
			PlaySound(inputpressed)
			remap_keys = not remap_keys
		end
		if remap_keys then
			UiMakeInteractive()
			UiTranslate(UiCenter(), 250)
			UiAlign("center middle")
			UiTranslate(0,300)
			UiColor(0,0,0, 0.7)
			UiImageBox("ui/common/box-solid-10.png", 250, 500, 10, 10)
			--Title
			UiTranslate(0,-200)
			UiFont("bold.ttf", 48)
			UiColor(1,1,1)
			UiText("Keybinds")
			UiTranslate(0, 50)
			UiFont("bold.ttf", 24)
			UiText("For spawnable objects")
			UiTranslate(0, 50)
			UiFont("regular.ttf", 18)
			UiText("Make it Dynamic")
			UiTranslate(0, 25)
			UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
			UiPush()
				if remap_rmb then
					UiText("Press Key")
					UiColor(0.5, 1, 0.5, 0.5)
					UiImageBox("ui/common/box-solid-6.png", 100, 25, 6, 6)
					if InputLastPressedKey() ~= "" then
						if InputPressed("esc") then
							SetString("savegame.mod.remap_rmb_spawn", "RMB")
							remap_rmb = false
						else
							SetString("savegame.mod.remap_rmb_spawn", InputLastPressedKey())
							remap_rmb = false
						end
					end
				else
					if UiTextButton(GetString("savegame.mod.remap_rmb_spawn"), 100, 25) then
						remap_rmb = true
					end
				end
			UiPop()
			UiTranslate(0, 50)
			UiText("Delete Components")
			UiTranslate(0, 25)
			UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
			UiPush()
				if remap_x then
					UiText("Press Key")
					UiColor(0.5, 1, 0.5, 0.5)
					UiImageBox("ui/common/box-solid-6.png", 100, 25, 6, 6)
					if InputLastPressedKey() ~= "" then
						if InputPressed("esc") then
							SetString("savegame.mod.remap_x_spawn", "X")
							remap_x = false
						else
							SetString("savegame.mod.remap_x_spawn", InputLastPressedKey())
							remap_x = false
						end
					end
				else
					if UiTextButton(GetString("savegame.mod.remap_x_spawn"), 100, 25) then
						remap_x = true
					end
				end
			UiPop()
		
			UiTranslate(0, 50)
			UiText("Make it Unbreakable")
			UiTranslate(0, 25)
			UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
			UiPush()
				if remap_c then
					UiText("Press Key")
					UiColor(0.5, 1, 0.5, 0.5)
					UiImageBox("ui/common/box-solid-6.png", 100, 25, 6, 6)
					if InputLastPressedKey() ~= "" then
						if InputPressed("esc") then
							SetString("savegame.mod.remap_c_spawn", "C")
							remap_c = false
						else
							SetString("savegame.mod.remap_c_spawn", InputLastPressedKey())
							remap_c = false
						end
					end
				else
					if UiTextButton(GetString("savegame.mod.remap_c_spawn"), 100, 25) then
						remap_c = true
					end
				end
			UiPop()
			UiTranslate(0, 100)
			UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
			UiPush()
				if UiTextButton("Reset", 150, 25) then
					SetString("savegame.mod.remap_rmb_spawn", "RMB")
					SetString("savegame.mod.remap_x_spawn", "X")
					SetString("savegame.mod.remap_c_spawn", "C")
				end
			UiPop()
			UiTranslate(0, 100)
			UiButtonImageBox("ui/common/optionsbox.png", 6, 6)
			UiFont("bold.ttf", 26)
			UiColor(1, 1, 1)
			if UiTextButton("Close", 400, 40) then
				remap_keys = false
			end
		end
	end
end